Package: AnnotationBustR
Version: 1.3.0
Date: 2020-09-23
Title: Extract Subsequences from GenBank Annotations
Author: Samuel R. Borstein <sam@borstein.com>, Brian O'Meara <bomeara@utk.edu>
Maintainer: Samuel R. Borstein <sam@borstein.com>
Depends: R (>= 3.4)
Imports: ape (>= 4.1), seqinr (>= 3.3-6)
Description: Extraction of subsequences into FASTA files from GenBank annotations where gene names may vary among accessions. Borstein & O'Meara (2018) <doi:10.7717/peerj.5179>.
License: GPL (>= 2)
LazyData: true
RoxygenNote: 7.1.1
Suggests: knitr, rmarkdown, testthat
VignetteBuilder: knitr
URL: https://github.com/sborstein/AnnotationBustR,
        https://www.ncbi.nlm.nih.gov/nuccore,
        https://peerj.com/articles/5179/
BugReports: https://github.com/sborstein/AnnotationBustR/issues
NeedsCompilation: no
Packaged: 2020-09-24 03:08:57 UTC; sam
Repository: CRAN
Date/Publication: 2020-09-24 08:10:13 UTC
Built: R 4.6.0; ; 2026-04-26 02:36:42 UTC; unix

Package: AnnotationBustR
Version: 2.0
Date: 2026-08-30
Title: Extract Subsequences from GenBank Annotations
Authors@R: 
  c(person(given = "Samuel R.",
           family = "Borstein",
           role = c("aut", "cre"),
           email = "sam@borstein.com",
           comment = c(ORCID = "0000-0002-7258-141X")),
    person(given = "Brian",
           family = "O'Meara",
           role = "aut",
		   email = "bomeara@utk.ed",
           comment = c(ORCID = "0000-0002-0337-5997")))
Maintainer: Samuel R. Borstein <sam@borstein.com>
Depends: R (>= 4.5)
biocViews:
Imports: Biostrings (>= 2.78.0), BSgenome (>= 1.78.0), dplyr (>=
        1.2.1), GenomicFeatures (>= 1.62.0), GenomicRanges (>= 1.62.0),
        magrittr (>= 2.0.5), rentrez (>= 1.2.4), stringr (>= 1.6.0)
Description: Extraction of subsequences into FASTA files from GenBank annotations where gene names may vary among accessions. Borstein & O'Meara (2018) <doi:10.7717/peerj.5179>.
License: GPL (>= 3)
LazyData: true
Suggests: knitr, rmarkdown, seqinr, testthat
VignetteBuilder: knitr
URL: https://github.com/sborstein/AnnotationBustR,
        https://www.ncbi.nlm.nih.gov/nuccore,
        https://peerj.com/articles/5179/,
        http://sborstein.github.io/AnnotationBustR/
BugReports: https://github.com/sborstein/AnnotationBustR/issues
Encoding: UTF-8
Config/roxygen2/version: 8.1.0
NeedsCompilation: no
Packaged: 2026-08-31 03:38:11 UTC; sam
Author: Samuel R. Borstein [aut, cre] (ORCID:
    <https://orcid.org/0000-0002-7258-141X>),
  Brian O'Meara [aut] (ORCID: <https://orcid.org/0000-0002-0337-5997>)
Repository: CRAN
Date/Publication: 2026-08-31 19:00:19 UTC

## ---- out.width = "100%", echo=FALSE,fig.align='left',fig.cap= "Fig. 1: AnnotationBustR Workflow. Steps in orange occur outside the package while steps in blue are core parts of AnnotationBustR and steps in green represent optional steps"----
knitr::include_graphics("workflow.jpg")

## ---- out.width = "100%", echo=FALSE, fig.align='left',fig.cap= "Fig. 2: GenBank features annotation for accession G295784.1 that contains ATP8 and ATP6. The words highlighted in yellow would fall under the column of Type. Here they are both CDS. The type of sequence is always listed farthest to the left in the features table. Colors in blue indicate terms that would be placed in the Name column, here indicating that the two CDS in this example are ATP8, labeled as ATPase8 and ATP6 respectively."----
knitr::include_graphics("featuresMarked.jpg")

## ---- echo=FALSE--------------------------------------------------------------
ex.frame<-rbind(c("ATP8","CDS","ATPase8"),c("ATP6","CDS","ATPase6"))
colnames(ex.frame)<-c("Locus","Type","Name")
ex.frame<-as.data.frame(ex.frame)
print(ex.frame)

## ----out.width = "100%", echo=FALSE,fig.align='left',fig.cap= "Fig. 1: AnnotationBustR Workflow. Steps in orange occur outside the package while steps in blue are core parts of AnnotationBustR and steps in green represent optional steps"----
knitr::include_graphics("workflow.jpg")

## ----out.width = "100%", echo=FALSE, fig.align='left',fig.cap= "Fig. 2: GenBank features annotation for accession G295784.1 that contains ATP8 and ATP6. The words highlighted in yellow would fall under the column of Type. Here they are both CDS. The type of sequence is always listed farthest to the left in the features table. Colors in blue indicate terms that would be placed in the Name column, here indicating that the two CDS in this example are ATP8, labeled as ATPase8 and ATP6 respectively."----
knitr::include_graphics("featuresMarked.jpg")

## ----echo=FALSE---------------------------------------------------------------
ex.frame <- rbind(c("ATP8","CDS","ATPase8"),c("ATP6","CDS","ATPase6"))
colnames(ex.frame) <- c("Feature","Type","Name")
ex.frame <- as.data.frame(ex.frame)
print(ex.frame)

#' Merging of two tables containing search terms to expand search term database for the AnnotationBust function.
#' @param ... the data frames of search terms you want to combine into a single data frame The Data frame(s) should have stringsAsFactors=FALSE listed if you want to sort them.
#' @param SortGenes Should the final data frame be sorted by gene name? Default is FALSE.
#' @return A new merged data frame with all the search terms combined from the lists supplied. If sort.gene=TRUE, genes will be sorted by name.
#' @description 
#' This function merges two data frames with search terms. This allows users to easily add search terms to data frames (either their
#' own or ones included in this package using data() as GenBank annotations for the same genes may vary in gene name. 
#' @examples
#' #load the list of search terms for mitochondrial genes
#' data(mtDNAterms) 
#' 
#' #Make a data.frame of new terms to add.
#' #This is a dummy example for a non-real annotation of COI, but lets pretend it is real.
#' add.name <- data.frame("COI","CDS", "CX1")
#' 
#' # make the column names the same for combination.
#' colnames(add.name) <- colnames(mtDNAterms)
#' 
#' #Run the merge search term function without sorting based on gene name.
#' new.terms <- MergeSearchTerms(add.name, mtDNAterms, SortGenes=FALSE)
#' 
#' #Run the merge search term function with sorting based on gene name.
#' new.terms <- MergeSearchTerms(add.name, mtDNAterms, SortGenes=TRUE)
#' 
#' #Merge search terms and create an additional column for introns and/or exons to extract
#' #In this example, add the trnK intron to the terms
#' 
#' ###Example With matK CDS and addint introns/exons for trnK###
#' #Subset out matK from cpDNAterms
#' cds.terms <- subset(cpDNAterms,cpDNAterms$Feature=="matK")
#' #Create a vecotr of NA so we can merge with the search terms for introns and exons
#' cds.terms <- cbind(cds.terms,(rep(NA,length(cds.terms$Feature))))
#' colnames(cds.terms)[4] <- "IntronExonNumber"
#' 
#' #Prepare a search term table for the intron and exons to remove
#' #We can start with the cpDNAterms for trnK
#' IntronExon.terms<-subset(cpDNAterms,cpDNAterms$Feature=="trnK")
#' 
#' #As we want to go for two exons, we will want the synonyms repeated as we are doing and intron
#' #and an exon
#' IntronExon.terms<-rbind(IntronExon.terms,IntronExon.terms)#duplicate the terms
#' 
#' #rep the sequence type we want to extract
#' IntronExon.terms$Type <- rep(c("intron","intron","exon","exon"))
#' IntronExon.terms$Feature <- rep(c("trnK_Intron","trnK_Exon2"),each=2)
#' IntronExon.terms <- cbind(IntronExon.terms,rep(c(1,1,2,2)))#Add intron/exon number info
#' 
#' #change column name for number info for IntronExon name
#' colnames(IntronExon.terms)[4] <- "IntronExonNumber"
#' 
#' #We can then merge everything together with MergeSearchTerms terms
#' IntronExonExampleTerms <- MergeSearchTerms(IntronExon.terms,cds.terms)
#' @export

MergeSearchTerms<-function(..., SortGenes=FALSE){
  dots <- list(...)
  check.names<-c("Feature","Type","Name","IntronExonNumber")
  if(length(unique(sapply(lapply(dots, dim), "[", 2)))>1){
    stop(paste("The input data frames are of different dimensions"))
  }
  for (i in sequence(length(dots))) {
    working <- TRUE
    if(!inherits(dots[[i]], "data.frame")) {
      stop(paste("The input object is the wrong format", sep=""))
      #working <- FALSE
    }
    if(dim(dots[[i]])[2]!=3&&dim(dots[[i]])[2]!=4) {
      stop(paste("The input object is the wrong dimensions", sep=""))
      #working <- FALSE
    }
    if(length(grep(TRUE,colnames(dots[[i]])!=check.names[1:unique(sapply(lapply(dots, dim), "[", 2))])>0)) {
      stop(paste("The columns for table",i, "do not have the proper names ('Feature','Type','Name' and if extracting introns/exons, the additional column 'IntronExonNumber')", sep=" "))
      #working <- FALSE
    }
  }
  new.terms <- rbind(...)
  if(SortGenes==TRUE) {
    new.terms <- new.terms[order(new.terms$Feature),]
  }
  row.names(new.terms)<-1:dim(new.terms)[[1]]
  return(new.terms)
}

#Test to see if merge search terms works properly.
#Will merge rDNA and Mitogenome terms together, which will be included in the package as data. 
#Do one to test if it merges and another to see if it sorts
test_that("merging search terms works", {
  data("mtDNAterms")#load mito search terms
  data("rDNAterms")#load rDNA search terms
  #No Sorting
  reg_merged<-rbind(mtDNAterms, rDNAterms)#simple rbind
  reg.test.merge<-MergeSearchTerms(mtDNAterms, rDNAterms, SortGenes = FALSE)#run the function w/out sorting
  expect_identical(dim(reg.test.merge), dim(reg_merged))#test to see if same dimensions
  expect_identical(reg.test.merge[1,], reg_merged[1,])#test to see the first row is the same 
  expect_identical(reg.test.merge[dim(reg.test.merge)[[1]],], reg_merged[dim(reg_merged)[[1]],])#test to see the last row is the same 
  #With Sorting
  sorted_merged<-reg_merged[order(reg_merged$Feature),]#order the manual ones
  row.names(sorted_merged)<-1:dim(sorted_merged)[[1]]#re-number
  sort.test.merge<-MergeSearchTerms(mtDNAterms, rDNAterms, SortGenes = TRUE)#run the function with sorting
  expect_identical(dim(sort.test.merge), dim(sorted_merged))#test to see if same dimensions
  expect_identical(sort.test.merge[1,], sorted_merged[1,])#test to see the first row is the same 
  expect_identical(sort.test.merge[dim(sort.test.merge)[[1]],], sorted_merged[dim(sorted_merged)[[1]],])#test to see the last row is the same
  }
)

#' Breaks up genbank sequences into their annotated components based on a set of search terms and writes each subsequence of interest to a FASTA for each accession number supplied.
#' @param Accessions A vector of GenBank accession numbers.
#' @param Terms A data frame of search terms. Search terms for animal mitogenomes, nuclear rRNA, chloroplast genomes, and plant mitogenomes are pre-made and can be loaded using the data() function. Additional terms can be added using the MergeSearchTerms function or a user supplied data frame may be provided.
#' @param Duplicates A vector of the features  which occur more than once in the sequence and for which the extraction of multiple copies is desired. Default is NULL. In the case more than one copy exists when set to NULL, only the first instance will be extracted.
#' @param DuplicateInstances A numeric vector the length of Duplicates of the number of duplicates for each duplicated feature you wish to extract. Only needs to be used if Duplicates are provided.Default is NULL (i.e. no duplicates).
#' @param TranslateSeqs Should coding sequences (cds) be translated to the corresponding peptide sequence? Options include, Only, None, or Both. Both returns both the DNA sequence and the corresponding peptide sequence. Default is FALSE.
#' @param DuplicateSpecies Logical. As to whether there are duplicate individuals per species. If TRUE, adds the accession number to the fasta header when writing sequences to file.
#' @param Prefix Character. If a prefix is specified, all output FASTA files written will begin with the prefix followed by an underscore. Default is NULL (i.e. no prefix).
#' @param TidyAccessions Logical. Should the accession table  have a single row per species? If numerous accessions for a species occur, they will be separated by a comma in the accession table. Default=TRUE.
#' @param Reference Logical. Should reference information be captured and added as a column to the accession table? Default is TRUE.
#' @param Verbose Logical. Should progress be printed to the screen. The current accession and species name will be printed to the screen.
#' @details 
#' The AnnotationBust function takes a vector of accession numbers and a data frame of search terms and extracts subsequences from genomes or concatenated sequences. This function connects directly to the NCBI database and requires a steady internet connection. The function writes files in the FASTA format to the current working directory and returns an accession table. Files append, so use different prefixes between runs, otherwise they will be added to current files in the working directory with the same name. 
#' 
#' AnnotationBustR comes with pre-made search terms for metazoan mitogenomes, plant mitogenomes, chloroplast genomes, and rDNA that can be loaded using data(mtDNAterms), data(mtDNAtermsPlants), data(cpDNAterms), and data(rDNAterms) respectively. Search terms can be completely made by the user if they follow a similar format with three columns. The first, Feature, should contain the name of the features as the user wishes it be displayed in their files as it is used to name the files and create the accession table. We recommend following a similar naming convention to what we currently have in the pre-made data frames to ensure that files are named properly, characters like "-" or ".", and names starting with numbers should be avoided as it can cause errors with R. The second column, Type, contains the type of subsequence it is (eg. CDS, exon, intron, rRNA, tRNA, misc_RNA, misc_feature, D_Loop). The last column, Name, consists of a possible synonym for the feature of interest as it might appear in an annotation. For numerous synonyms for the same locus, one should have each synonym as its own row. An additional fourth column is needed for extracting introns/exons. This column, called IntronExonNumber should contain the number of the desired intron or exon to extract. If extracting both introns/exons and non-intron/exon sequences the fourth column should be NA for non-intron/exon sequence types. See the examples below and the vignette for detailed examples on extracting intron and exons. 
#' 
#' In the event that an accession is not found on NCBI, the message “Accession # not found on NBI”.
#' 
#' For a more detailed walk-through on using AnnotationBust you can access the vignette with vignette("AnnotationBustR).
#' @return Writes a fasta file(s) to the current working directory selected for each unique subsequence of interest in Terms containing all the accession numbers the subsequence was found in.
#' @return An accesion table of class data.frame.
#' @examplesIf interactive()
#' \donttest{
#' ncbi.accessions <- c("FJ706295","FJ706343","FJ706292")
#' data(rDNAterms)#load rDNA search terms from AnnotationBustR
#' my.sequences <- AnnotationBust(Accessions = ncbi.accessions, rDNAterms, DuplicateSpecies=TRUE, 
#' Prefix="Example1", Reference = TRUE)
#' my.sequences
#' 
#' ###Example With matK CDS and addint introns/exons for trnK###
#' #Subset out matK from cpDNAterms
#' cds.terms <- subset(cpDNAterms,cpDNAterms$Feature=="matK")
#' #Create a vecotr of NA so we can merge with the search terms for introns and exons
#' cds.terms <- cbind(cds.terms,(rep(NA,length(cds.terms$Feature))))
#' colnames(cds.terms)[4] <- "IntronExonNumber"
#' 
#' #Prepare a search term table for the intron and exons to remove
#' #We can start with the cpDNAterms for trnK
#' IntronExon.terms<-subset(cpDNAterms,cpDNAterms$Feature=="trnK")
#' 
#' #As we want to go for two exons, we will want the synonyms repeated as we are doing and intron
#' #and an exon
#' IntronExon.terms<-rbind(IntronExon.terms,IntronExon.terms)#duplicate the terms
#' 
#' #rep the sequence type we want to extract
#' IntronExon.terms$Type <- rep(c("intron","intron","exon","exon"))
#' IntronExon.terms$Feature <- rep(c("trnK_Intron","trnK_Exon2"),each=2)
#' IntronExon.terms <- cbind(IntronExon.terms,rep(c(1,1,2,2)))#Add intron/exon number info
#' 
#' #change column name for number info for IntronExon name
#' colnames(IntronExon.terms)[4] <- "IntronExonNumber"
#' 
#' #We can then merge everything together with MergeSearchTerms terms
#' IntronExonExampleTerms <- MergeSearchTerms(IntronExon.terms,cds.terms)
#'
#' #Run AnnotationBust
#' IntronExon.example <- AnnotationBust(Accessions=c("KX687911.1", "KX687910.1"),
#' Terms=IntronExonExampleTerms, Prefix="DemoIntronExon")
#' }
#' @references Borstein SR, and O’Meara BC. 2018. AnnotationBustR: an R package to extract subsequences from GenBank annotations. PeerJ 6:e5179. 10.7717/peerj.5179.
#' @author Samuel R. Borstein, Brian C. O'Meara 
#' @export

AnnotationBust <- function(Accessions, Terms, Duplicates = NULL, DuplicateInstances = NULL, 
                               TranslateSeqs = "None", DuplicateSpecies = FALSE,  
                               Prefix = NULL, TidyAccessions = TRUE, Reference = TRUE, Verbose = TRUE){
  
  uni.feature <- unique(Terms$Feature)#Subset unique Loci

  if(is.null(Duplicates)==FALSE){#Routine for naming if DuplicateInstances==TRUE
    if(!length(Duplicates)==length(DuplicateInstances)){#Check and error if Duplicates does not equal DuplicateInstances
      stop("Length of Duplicates and DuplicateInstances is not equal. You must specify the number of duplicates for each feature with duplicates you would like to extract")
    }
    new.file.names <- character(length = 0)#prep file names
    dup.frame <- data.frame(Duplicates, DuplicateInstances)#prep duplicates
    singles <- uni.feature[uni.feature %in% dup.frame$Duplicates==FALSE]#get matching duplicates
    doubles <- uni.feature[uni.feature %in% dup.frame$Duplicates==TRUE]#get matching duplicates
    for (i in 1:length (doubles)){#for each duplicate
      sub.dups <- subset(dup.frame, dup.frame$Duplicates %in% doubles[i]==TRUE)#subset the duplicate genes
      number.names <- paste0(sub.dups$Duplicates,"_", 1:sub.dups$DuplicateInstances)#add duplicate numbers to names
      new.file.names <- append(new.file.names, number.names)#append the new pasted file names
    }
    file.names <- c(as.vector(singles), new.file.names)#combo the names of single and duplicate loci
  }else {file.names <- as.vector(uni.feature)}#if no duplicates, unique feature names are the file names
  Accession.Table <- data.frame(data.frame(matrix(NA, nrow = length(Accessions), ncol = 1+length(file.names))))#make empty accession table
  colnames(Accession.Table) <- c("Species",file.names)#attach loci names as column names
  if(Reference == TRUE){#if references are requested
    Accession.Table$Reference <- NA#add corresponding column in accession table
  }
  if(is.null(Prefix)){#prepare prefix naming for files
    File.Prefix <- NULL#If no prefix, set to NULL
  }else{
    File.Prefix <- paste0(Prefix,"_")#Add underscore if prefix exists for tidyness
    }
  #For each accession
  for(accession.index in 1:length(Accessions)){
    Current.Accession <- Accessions[accession.index]#get the accession for the current accession index
    raw_gb_text <- try(rentrez::entrez_fetch(db = "nuccore", id = Current.Accession, rettype = "gbwithparts", retmode = "text"))#Use entrez to access accession
    if(inherits(raw_gb_text, "try-error")){#Flag if try error
      message("Could not connect to NCBI")#message error and skip to next accession.
      next
    }
    if(grepl(pattern = "Error: F a i l e d  t o  u n d e r s t a n d",raw_gb_text)){#search for errors
      message(paste0("Working On Accession ", accession.index, " of ", length(Accessions),": ", Accessions[accession.index], " not found on NCBI"))#message if not found at populate the Accession Table
      Accession.Table[accession.index,1:length(colnames(Accession.Table))]<-paste("Failed to find", Accessions[accession.index],sep=" ")#Add not found info
      next#skip to next
    }
    gb_lines <- strsplit(raw_gb_text, "\n|\r\n")[[1]]#string split lines
    org_line_index <- grep("^\\s*ORGANISM", gb_lines)#Find organism line
    org_line <- gb_lines[org_line_index]#Subset line grabbed above for organism
    organism_name <- gsub(" ","_",trimws(sub("^\\s*ORGANISM", "", org_line)))#Extract organism name and replace speces with under scores
    
    if(Reference == TRUE){#If references are requested
      Ref2Store <- ParseReference(ReadGB = gb_lines)#Make the reference using the helper function
      Accession.Table[accession.index,"Reference"] <- Ref2Store#store the reference
    }
    
    if(Verbose == TRUE){#if verbose, print progress
      message(paste("Working On Accession ", accession.index, " of ", length(Accessions),": ",  Accessions[accession.index],", ",organism_name, sep=""))
    }
    Accession.Table[accession.index,"Species"] <- organism_name
    current_record <- parse_genbank(ReadGB = gb_lines, primary_accession = Current.Accession)#Parse the accession and its annotations.
    ifelse(DuplicateSpecies==TRUE, seq.name<-paste(organism_name,Accessions[accession.index],sep = "_"), seq.name<-organism_name)#For duplicate species, append the accesion to end of species name
    for(term.index in seq_along(uni.feature)){#for each term
      synonyms <- Terms[Terms$Feature==uni.feature[term.index],]#subset synonyms
      for(synonym.index in 1:nrow(synonyms)){#for each synonym
        found.type <- base::grep(pattern = paste0("^",synonyms$Type[synonym.index],"$"),x = names(current_record))#find feature type
        if(length(found.type)==1){#If type is found in annotations for the accession
          term.search <- base::grep(pattern = paste0("^",synonyms$Name[synonym.index],"$"),x = current_record[[found.type]]$gene)#Check genes first
          ifelse(length(term.search)>0, term.search <- term.search, term.search <- base::grep(pattern = paste0("^",synonyms$Name[synonym.index],"$"),x = current_record[[found.type]]$product))#if not in genes, check products
          ifelse(length(term.search)>0, term.search <- term.search, term.search <- base::grep(pattern = paste0("^",synonyms$Name[synonym.index],"$"),x = current_record[[found.type]]$note))#if not in genes, check products
          if(length(term.search)==0 && names(current_record)[[found.type]]=="D-loop"){#Facilitate D-loop discovery
            term.search <- base::grep(pattern = paste0("^",synonyms$Name[synonym.index],"$"),x = current_record[[found.type]]$type)
          }
          if(synonyms[synonym.index,]$Type%in%c("exon","intron")){#If the feature is an intron OR an exon
            temp.term <- current_record[[found.type]][term.search,]#Make a temporary reduced dataset to search
            IntronExonHits <- which(temp.term$number==synonyms$IntronExonNumber[synonym.index])#Find the numbers
            term.search <- term.search[IntronExonHits]#subset based on numbers
          }
          if(length(term.search)>0){#If successful search
            FeatureGrab <- current_record[[found.type]][term.search,]#grab the features
            FeatureIndexCheck <- unique(FeatureGrab$feat_index)#Check to see if there is a single unique ID for annotation or several.
            if(uni.feature[term.index] %in% Duplicates == FALSE){#If current feature does not have duplicate instances requested
              Extracted.seq <- extract_ranges_seq(full_sequence = current_record$sequence, target_gr = FeatureGrab[FeatureGrab$feat_index==FeatureIndexCheck[1]])#Extract Seq based on feature ranges
              names(Extracted.seq) <- seq.name#name sequence for species
              if(synonyms$Type[synonym.index] == "CDS"){#If a CDS, use control flow based on users desire for translation
                if(TranslateSeqs%in%c("Only","Both")){#Translate if desired
                  Current.Trans <- unique(FeatureGrab[FeatureGrab$feat_index==FeatureIndexCheck[1]]$translation)#Get the current translation
                  if(length(Current.Trans) == 1){#ensure only single translation across CDS
                    TransString <- Biostrings::AAStringSet(Current.Trans)#create AA stringset object for translation
                    names(TransString) <- seq.name#name sequence for species
                    Biostrings::writeXStringSet(x = TransString, filepath = paste0(File.Prefix,uni.feature[term.index],"_Translation",".fasta"), format = "fasta",append = T)#Write Translation
                    Accession.Table[accession.index,grep(paste0("\\b",uni.feature[term.index],"\\b"), colnames(Accession.Table))] <- Accessions[accession.index]#Fill the Accession table
                  }
                }
                if(TranslateSeqs%in%c("Both","None")){#Write the Nucleotides if Both or No Translation
                  Biostrings::writeXStringSet(x = Extracted.seq, filepath = paste0(File.Prefix,uni.feature[term.index],".fasta"), format = "fasta",append = T)#Write DNA sequence
                  Accession.Table[accession.index,grep(paste0("\\b",uni.feature[term.index],"\\b"), colnames(Accession.Table))] <- Accessions[accession.index]
                }
                break
              }else{#if not a CDS
                Biostrings::writeXStringSet(x = Extracted.seq, filepath = paste0(File.Prefix,uni.feature[term.index],".fasta"), format = "fasta",append = T)#Write DNA sequence
                Accession.Table[accession.index,grep(paste0("\\b",uni.feature[term.index],"\\b"), colnames(Accession.Table))] <- Accessions[accession.index]#fill the Accession table
                break
              }
            }else{#if duplicates
              DupID <- which(uni.feature[term.index]==Duplicates)#In case order is off, make sure we get the right one.
              CurrentDupTargets <- DuplicateInstances[DupID]#Subset out the current number of instances desired
              if(CurrentDupTargets>length(unique(FeatureGrab$feat_index))){#Check that the specified number is not greater than thos in the annotations
                CurrentDupTargets <- length(FeatureGrab)#If greater than the number in the features, make it the number in the features
                warning(paste0("Number of duplicates specified is greater than the number in annotations. Readjusting duplicates for ", uni.feature[term.index]," to ", CurrentDupTargets))#and warn user
              }
              for(DupIndex in 1:CurrentDupTargets){#for each duplicate
                CurrentDup <- FeatureGrab[FeatureGrab$feat_index == FeatureIndexCheck[DupIndex], ]#subset the current duplicate instance
                Extracted.seq <- extract_ranges_seq(full_sequence = current_record$sequence, target_gr = CurrentDup[CurrentDup$feat_index==FeatureIndexCheck[DupIndex]])#Extract Seq based on feature ranges
                names(Extracted.seq) <- seq.name#name sequence for species
                if(synonyms$Type[synonym.index] == "cds"){#If a CDS, use control flow based on users desire for translation
                  if(TranslateSeqs%in%c("Only","Both")){#Translate if desired
                    Current.Trans <- unique(CurrentDup$translation)#Get the current translation
                    if(length(Current.Trans) == 1){#ensure only single translation across CDS
                      TransString <- Biostrings::AAStringSet(Current.Trans)#create AA stringset object for translation
                      names(TransString) <- seq.name#name sequence for species
                      Biostrings::writeXStringSet(x = TransString, filepath = paste0(File.Prefix,uni.feature[term.index],"_",DupIndex,"_Translation",".fasta"), format = "fasta",append = T)#Write Translation
                      Accession.Table[accession.index,grep(paste0("\\b",uni.feature[term.index],"_",DupIndex,"\\b"), colnames(Accession.Table))] <- Accessions[accession.index]#Fill the Accession table
                    }
                  }
                  if(TranslateSeqs%in%c("Both","None")){#Write the Nucleotides if Both or No Translation
                    Biostrings::writeXStringSet(x = Extracted.seq, filepath = paste0(File.Prefix,uni.feature[term.index],"_",DupIndex,".fasta"), format = "fasta",append = T)#Write DNA sequence
                    Accession.Table[accession.index,grep(paste0("\\b",uni.feature[term.index],"_",DupIndex,"\\b"), colnames(Accession.Table))] <- Accessions[accession.index]#Fill the Accession table
                  }
                }else{#if not a CDS
                  Biostrings::writeXStringSet(x = Extracted.seq, filepath = paste0(File.Prefix,uni.feature[term.index],"_",DupIndex,".fasta"), format = "fasta",append = T)#Write DNA sequence
                  Accession.Table[accession.index,grep(paste0("\\b",uni.feature[term.index],"_",DupIndex,"\\b"), colnames(Accession.Table))] <- Accessions[accession.index]#Fill the Accession table
                }
              }#for loop duplicate ends
              break#break out of current term
            }#duplicate control end
          }#if length search end
        }#if feature type is found end
      }#end of synonym for loop
    }#for each term loop end
  }#Accession For loop end
  #Make Final Accession Table
  if(TidyAccessions==TRUE){
    UniqueSpecies<-unique(Accession.Table$Species)#Get unique species in table
    Final.Accession.Table<-data.frame(data.frame(matrix(NA, nrow = length(UniqueSpecies), ncol = 1+length(file.names))))#make empty accession table
    colnames(Final.Accession.Table)<-c("Species",file.names)#attach loci names as colnames
    if(Reference == TRUE){#if references are requested
      Final.Accession.Table$Reference <- NA#Make empty reference column to populate
    }    
    for (species.index in 1:length(UniqueSpecies)){#for each species
      current.spec<-subset(Accession.Table,Accession.Table$Species==UniqueSpecies[species.index])#subset species
      Final.Accession.Table[species.index,1]<-UniqueSpecies[species.index]#Assign species name to final table
      for (gene.index in 2:length(Accession.Table)){#for each feature
        current.loci<-current.spec[,gene.index]#The current column/loci
        found.accessions<-subset(current.loci,!is.na(current.loci))#subset the ones that are present
        numbers<-ifelse(length(found.accessions)==0, NA, paste(found.accessions, sep=",", collapse=","))#ifelse statemen, if not present, fill with NA
        Final.Accession.Table[species.index,gene.index]<-numbers#assign to cells in final table
        Sort.Final.Accession.Table<-Final.Accession.Table[order(Final.Accession.Table$Species),]#Sort by species name
      }
      rownames(Sort.Final.Accession.Table)<-1:nrow(Sort.Final.Accession.Table)#Assign rownames
    }
  }else{
    Final.Accession.Table<-Accession.Table#assign the accession table to return prior to sorting
    Sort.Final.Accession.Table<-Final.Accession.Table[order(Final.Accession.Table$Species),]#sort table by species
    rownames(Sort.Final.Accession.Table)<-1:nrow(Sort.Final.Accession.Table)#assign rownames
  } 
  return(Final.Accession.Table)#return accession table
}


                      

#Test that the main function AnnotationBust is in fact working properly
#Run on one mitogenome which is missing ND5, which should return NA
#Run with duplicate genes and translated seqs
test_that("AnnotationBust Works",{
skip_on_cran()
data(mtDNAterms)
#load("sysdata.rda")#Manual output of all genes. Missing ND5 gene (misc_feature). Should be missing in real run.
#test with accession=JN628859.1

AnnotationBustOut <- structure(list(Species = "Pallidochromis_tokolosh", tRNA_Phe = "JN628859.1",
    rRNA_12S = "JN628859.1", tRNA_Val = "JN628859.1", rRNA_16S = "JN628859.1",
    ND1 = "JN628859.1", tRNA_Ile = "JN628859.1", tRNA_Gln = "JN628859.1",
    tRNA_Met = "JN628859.1", ND2 = "JN628859.1", tRNA_Trp = "JN628859.1",
    tRNA_Ala = "JN628859.1", tRNA_Asn = "JN628859.1", tRNA_Cys = "JN628859.1",
    tRNA_Tyr = "JN628859.1", COI = "JN628859.1", tRNA_Asp = "JN628859.1",
    COII = "JN628859.1", tRNA_Lys = "JN628859.1", ATP8 = "JN628859.1",
    ATP6 = "JN628859.1", COIII = "JN628859.1", tRNA_Gly = "JN628859.1",
    ND3 = "JN628859.1", tRNA_Arg = "JN628859.1", ND4L = "JN628859.1",
    ND4 = "JN628859.1", tRNA_His = "JN628859.1", ND5 = NA, ND6 = "JN628859.1",
    tRNA_Glu = "JN628859.1", CYTB = "JN628859.1", tRNA_Thr = "JN628859.1",
    tRNA_Pro = "JN628859.1", D_loop = "JN628859.1", tRNA_Ser1 = "JN628859.1",
    tRNA_Ser2 = "JN628859.1", tRNA_Leu1 = "JN628859.1", tRNA_Leu2 = "JN628859.1",Reference = "Darrin Hulsey,C., Keck,B.P., Alamillo,H. and O'Meara,B.C. Mitochondrial genome primers for Lake Malawi cichlids. Mol Ecol Resour 13 (3), 347-353 (2013)."), names = c("Species",
"tRNA_Phe", "rRNA_12S", "tRNA_Val", "rRNA_16S", "ND1", "tRNA_Ile",
"tRNA_Gln", "tRNA_Met", "ND2", "tRNA_Trp", "tRNA_Ala", "tRNA_Asn",
"tRNA_Cys", "tRNA_Tyr", "COI", "tRNA_Asp", "COII", "tRNA_Lys",
"ATP8", "ATP6", "COIII", "tRNA_Gly", "ND3", "tRNA_Arg", "ND4L",
"ND4", "tRNA_His", "ND5", "ND6", "tRNA_Glu", "CYTB", "tRNA_Thr",
"tRNA_Pro", "D_loop", "tRNA_Ser_1", "tRNA_Ser_2", "tRNA_Leu_1",
"tRNA_Leu_2", "Reference"), class = "data.frame", row.names = c(NA, -1L))
setwd (tempdir())
test.out<-try(AnnotationBust(Accessions = "JN628859.1", Terms = mtDNAterms, Duplicates = c("tRNA_Leu","tRNA_Ser"), DuplicateInstances = c(2,2), TranslateSeqs = "Only"))
if ("try-error"%in%class(test.out)) {
    skip("could not connect to remote database")
}else{
    expect_identical(AnnotationBustOut[1,],test.out[1,])
    }
}
)

#################################################
###############Extract Feature Tags##############
#################################################
#' Internal Function To Extract Annotation Features
#' @param text Character. Chunk of GenBank annotations used for searching
#' @param tag Character. Tag to search for.
#' @param remove_spaces Logical. Should spaces be removed?
#' @noRd
#' @author Samuel R. Borstein

extract_gb_tag <- function(text, tag, remove_spaces = FALSE) {
  pattern <- paste0("/", tag, "=(\"[^\"]+\"|[^\\s]+)")#general search pattern
  extracted <- stringr::str_extract(text, pattern)#Find relevant line and isolate
  if (is.na(extracted)) return(NA)#If not extracted, make NA
  cleaned <- stringr::str_replace(extracted, paste0("/", tag, "="), "")#remove annotation tag
  cleaned <- stringr::str_replace_all(cleaned, "\"", "")#remove non-target text
  if (remove_spaces == TRUE){#If to remove spaces control flow. We choose not to by default and hard code it.
    cleaned <- gsub("\\s+", "", cleaned)#if there are spaces, collapse them.
  }
  return(cleaned)
}

############################################################
################Parse Coordinates & Joins###################
############################################################
#' Internal Parser Function
#' @param coord_str Character vector representing a coordinate string of a GenBank accession. Obtained via parse_genbank.
#' @param AccNo description
#' @examples
#' Accessions <- c("PV747861.1")
#' raw_gb_text <- rentrez::entrez_fetch(db = "nuccore", id = accession, rettype = "gbwithparts", retmode = "text")#Use entrez to access accession
#' gb_lines <- strsplit(raw_gb_text, "\n|\r\n")[[1]]#string split lines
#' parse_genbank(ReadGB = gb_lines)
#' @noRd
#' @author Samuel R. Borstein
parse_gb_coordinates <- function(coord_str, primary_accession) {
  coord_str <- gsub("\\s+", "", coord_str)#Remove spacing between ranges
  is_global_comp <- grepl("^complement\\(join\\(", coord_str)#Check for complements
  
  inner_str <- coord_str#Set coord_str as innr_str
  if (is_global_comp) {#if a global complement
    inner_str <- sub("^complement\\(join\\(", "", inner_str)#Remove leading text
    inner_str <- sub("\\)\\)$", "", inner_str)#remove anchor )
  } else if (grepl("^(join|order)\\(", inner_str)) {#if not a global complement
    inner_str <- sub("^(join|order)\\(", "", inner_str)#remove text around
    inner_str <- sub("\\)$", "", inner_str)#remove anchor )
  }
  
  exon_strs <- strsplit(inner_str, ",")[[1]]#String split to chunks
  if (is_global_comp) exon_strs <- rev(exon_strs)#if global complement
  
  parsed_exons <- list()#Initialize storage for parsed exons
  for (j in seq_along(exon_strs)) {#for each potential exon
    e_str <- exon_strs[j]#get positions
    e_strand <- ifelse(is_global_comp || grepl("complement", e_str), "-", "+")#ifelse for strand determination based on presence of complement or global complement
    
    e_seqname <- primary_accession#set sequence name to be Accession Number
    if (grepl(":", e_str)) {#if colon is found
      e_seqname <- sub(":.*", "", e_str)##remove ... for getting positions
      e_seqname <- gsub("[^A-Za-z0-9_.]", "", e_seqname)#make sure Accession is just accession
    }
    
    nums <- as.numeric(unlist(regmatches(e_str, gregexpr("\\d+", e_str))))#force numeric for numbers and getting positions
    if (length(nums) >= 1) {#if 1 or more generate a list with the name, start position, end position, strand +/-, intron/exon number, and if a join 
      parsed_exons[[length(parsed_exons) + 1]] <- list(
        seqnames = e_seqname,
        start = min(nums),
        end = max(nums),
        strand = e_strand,
        number = j,  
        loctype = ifelse(grepl("join", coord_str), "join", "normal")
      )
    }
  }
  return(dplyr::bind_rows(parsed_exons))#return the 
}

###############################################################
##############Main Internal Parser Function####################
###############################################################

#' Internal Parser Function
#' @param ReadGB Character vector of read in GenBank accession.
#' @examples
#' raw_gb_text <- rentrez::entrez_fetch(db = "nuccore", id = accession, rettype = "gbwithparts", retmode = "text")#Use entrez to access accession
#' gb_lines <- strsplit(raw_gb_text, "\n|\r\n")[[1]]#string split lines
#' parse_genbank(ReadGB = gb_lines)
#' @noRd
#' @author Samuel R. Borstein
#' @importFrom magrittr %>%

parse_genbank <- function(ReadGB, primary_accession) {
  orig_start <- grep("^ORIGIN", ReadGB)#Find origin flag for the sequence
  end_idx <- grep("^//", ReadGB)#Find end of sequence flag
  if (length(orig_start) > 0 && length(end_idx) > 0) {#if we have these found
    #remove line numbers and past into a single string from origin to end
    clean_dna <- gsub("[0-9 ]", "", paste(ReadGB[(orig_start + 1):(end_idx[length(end_idx)] - 1)], collapse = ""))
    full_sequence <- Biostrings::DNAStringSet(clean_dna)#Make this a DNAStringSet object
    names(full_sequence) <- primary_accession#Set accession to be the name
  } else stop("Could not find ORIGIN sequence.")#Kill if origin not found
  
  
  feat_start <- grep("^FEATURES", ReadGB)#Find the start of the features
  feat_lines <- ReadGB[(feat_start + 1):(orig_start - 1)]#Add one for start of Annotation location
  #Need to allow numbers, hyphens, to identify feature boundaries
  new_feat_idx <- grep("^ {5}[A-Za-z0-9_'-]+", feat_lines)##Match 5 spaces and alphabetical to defining features

  all_rows <- list()#Generate Empty lst
  
  #Extract basic features
  for (i in seq_along(new_feat_idx)) {#For each feature
    start_idx <- new_feat_idx[i]#Grab starting position
    end_idx <- ifelse(i < length(new_feat_idx), new_feat_idx[i+1] - 1, length(feat_lines))#Grab the end of current feature based on start of next feature
    chunk <- feat_lines[start_idx:end_idx]#subset the current feature out
    
    feat_type <- stringr::str_trim(stringr::str_extract(chunk[1], "^ {5}[A-Za-z0-9_'-]+"))#Grab current feature type from annotation
    chunk_collapsed <- paste(stringr::str_trim(chunk), collapse = " ")#Collapse feature into single line
    
    #isolate coordinates
    coord_str <- sub("^[A-Za-z0-9_'-]+\\s+", "", chunk_collapsed)#Sub out type prior to info
    coord_str <- stringr::str_trim(sub("/.*", "", coord_str))#Sub out spaces
    
    gene <- extract_gb_tag(chunk_collapsed, "gene")#Extract gene name
    locus_tag <- extract_gb_tag(chunk_collapsed, "locus_tag")#Extract Locus tag
    product <- extract_gb_tag(chunk_collapsed, "product")#Extract Product
    protein_id <- extract_gb_tag(chunk_collapsed, "protein_id")#Extract protein ID
    transcript_id_tag <- extract_gb_tag(chunk_collapsed, "transcript_id") 
    translation <- extract_gb_tag(chunk_collapsed, "translation", remove_spaces = TRUE)#If CDS, get the translation
    note <- extract_gb_tag(chunk_collapsed, "note")#Capture any notes
    
    coords_df <- parse_gb_coordinates(coord_str, primary_accession)#parse coordinates
    
    if (nrow(coords_df) > 0) {#populate the coordinate tibble for each feature type with inde, gene, tag, product, protein ID, transcipt, translation, and any relevant notes
      coords_df$feat_index <- i  
      coords_df$type <- feat_type
      coords_df$gene <- gene
      coords_df$locus_tag <- locus_tag
      coords_df$product <- product
      coords_df$protein_id <- protein_id
      coords_df$transcript_id_tag <- transcript_id_tag 
      coords_df$translation <- translation
      coords_df$note <- note
      
      all_rows[[length(all_rows) + 1]] <- coords_df
    }
  }
  
  master_df <- suppressWarnings(dplyr::bind_rows(all_rows))#Merge rows together for feature types
  
  #Check Columns to guarantee all feature tracking columns exist (prevents 'object not found' errors)
  expected_cols <- c("gene", "locus_tag", "protein_id", "transcript_id_tag")
  for (col in expected_cols) {
    if (!(col %in% colnames(master_df))) {
      master_df[[col]] <- NA
    }
  }
  
  #Strip explicit exons as they ruin trans-splicing logic so they can be inferred later.
  master_df <- master_df %>% dplyr::filter(type != "exon")
  
  #Assign genbankr like transcript IDs for keeping track internally
  master_df <- master_df %>%
    dplyr::mutate(
      #Prioritize explicit eukaryotic isoform IDs prior to falling back to locus_tag and gene
      base_name = dplyr::coalesce(transcript_id_tag, protein_id, locus_tag, gene, paste0("unnamed_", type, "_", feat_index))
    ) %>%
    dplyr::group_by(base_name) %>%
    dplyr::arrange(feat_index) %>%
    dplyr::mutate(
      instance = cumsum(c(1, diff(feat_index) > 15))
    ) %>%
    dplyr::ungroup() %>%
    dplyr::mutate(
      transcript_id = dplyr::if_else(
        !is.na(transcript_id_tag) | !is.na(protein_id), 
        base_name,
        dplyr::if_else(
          !is.na(gene) & !is.na(locus_tag), 
          paste0(gene, ".", instance, "_", locus_tag), 
          paste0(base_name, ".", instance)
        )
      )
    )
  
  #Protect biological joins, sequentially number independent pieces
  master_df <- master_df %>%
    dplyr::group_by(transcript_id, type) %>%
    dplyr::arrange(feat_index, number, .by_group = TRUE) %>%
    dplyr::mutate(
      number = if (any(loctype == "join")) number else as.integer(dplyr::row_number()),
      part_id = paste0(transcript_id, "_", type, "_", number)
    ) %>%
    dplyr::ungroup()
  
  #Exon inference and tracking
  cds_rna_df <- master_df %>% dplyr::filter(type %in% c("CDS", "mRNA", "tRNA", "rRNA"))
  if (nrow(cds_rna_df) > 0) {
    inferred_exons <- cds_rna_df
    inferred_exons$type <- "exon"
    inferred_exons$part_id <- paste0(inferred_exons$transcript_id, "_exon_", inferred_exons$number)
    master_df <- dplyr::bind_rows(master_df, inferred_exons)
  }
  
  #mRNA inference
  if (!("mRNA" %in% master_df$type)) {
    cds_df <- master_df %>% dplyr::filter(type == "CDS")
    if (nrow(cds_df) > 0) {
      inferred_mrna <- cds_df
      inferred_mrna$type <- "mRNA"
      inferred_mrna$part_id <- sub("_CDS_", "_mRNA_", inferred_mrna$part_id)
      master_df <- dplyr::bind_rows(master_df, inferred_mrna)
    }
  }
  
  #Convert to standard GRanges
  master_df <- as.data.frame(master_df)
  master_gr <- GenomicRanges::makeGRangesFromDataFrame(master_df, keep.extra.columns = TRUE)
  main_types <- c("gene", "CDS", "exon", "mRNA")
  
  #Build the core output list
  final_output <- list(
    sequence = full_sequence,
    gene = master_gr[master_gr$type == "gene"],
    CDS = master_gr[master_gr$type == "CDS"],
    exon = master_gr[master_gr$type == "exon"],
    mRNA = master_gr[master_gr$type == "mRNA"]
  )
  
  #Dynamically extract and append any other feature types to list
  other_gr <- master_gr[!master_gr$type %in% main_types]
  if (length(other_gr) > 0) {
    other_split <- as.list(GenomicRanges::split(other_gr, other_gr$type))
    final_output <- c(final_output, other_split)
  }
  
  return(final_output)#Return final table of features
}

######################################
#####RANGE SEQ EXTRACT FUNCTION#######
######################################
#' Extract Sequences Based on Parsed Ranges
#' @param full_sequence The full sequence object as a DNAStringSet.
#' @param target_gr A GRanges object containing coordinate ranges for extraction.
#' @examples
#' raw_gb_text <- rentrez::entrez_fetch(db = "nuccore", id = "PV747861.1", rettype = "gbwithparts", retmode = "text")#Use entrez to access accession
#' gb_lines <- strsplit(raw_gb_text, "\n|\r\n")[[1]]#string split lines
#' parse_genbank(ReadGB = gb_lines)
#' @noRd
#' @author Samuel R. Borstein
#' @import BSgenome
extract_ranges_seq <- function(full_sequence, target_gr) {
  
  #Check there is a transcript_id column for splitting joined pieces
  if (!("transcript_id" %in% colnames(GenomicRanges::mcols(target_gr)))) {
    #If provided as a raw/custom GRanges without our standard columns, 
    #just number each row individually so it doesn't crash.
    target_gr$transcript_id <- paste0("custom_range_", seq_along(target_gr))
  }
  
  #Split into a GRangesList by transcript_id
  #Needed to keep multi-exons together while keeping things distinct
  gr_list <- GenomicRanges::split(target_gr, target_gr$transcript_id)
  
  #Extract and/or stitch target sequence(s)
  seqs <- GenomicFeatures::extractTranscriptSeqs(x = full_sequence, transcripts = gr_list)
  
  return(seqs)#return the sequence
}

######################################
#####Parse References#################
######################################
#' Internal Reference Parser Function
#' @param ReadGB Character vector of read in GenBank accession.
#' @examples
#' raw_gb_text <- rentrez::entrez_fetch(db = "nuccore", id = "PV747861.1", rettype = "gbwithparts", retmode = "text")#Use entrez to access accession
#' gb_lines <- strsplit(raw_gb_text, "\n|\r\n")[[1]]#string split lines
#' ParseReference(ReadGB = gb_lines)
#' @noRd
#' @author Samuel R. Borstein
ParseReference <- function(ReadGB){
  ref_indices <- grep("^\\s*REFERENCE", ReadGB)#get reference flags

  #Limit to latest reference if multiple 
  if (length(ref_indices) > 1) {#if more than 1 reference
    ref_lines <- ReadGB[1:(ref_indices[2] - 1)]
  }else{
    ref_lines <- ReadGB
  }
  
  #Get the reference matches
  ref_matches <- grep("^\\s*(AUTHORS|TITLE|JOURNAL)", ref_lines, value = TRUE)
  #Clean flags/white space
  clean_ref <- trimws(gsub("^\\s*(AUTHORS|TITLE|JOURNAL)\\s+", " ", ref_matches))
  #Prep full reference for storage via paste. We need to add some punctuation here.
  full_ref <- paste(clean_ref[1], " ", clean_ref[2],". ", clean_ref[3], ".", sep = "")
  return(full_ref)#return the reference
}

#' Mitochondrial DNA Search Terms for Animals
#'
#' A data frame containing search terms for animal mitochondrial loci. Can be subset for loci of 
#'  interest. Columns are as follows and users should follow the column format if they wish to
#'  add search terms using the MergeSearchTerms function:
#'
#' @format A data frame of of 254 rows and 3 columns
#' \itemize{
#'   \item Feature: Feature name, FASTA files will be written with this name.
#'   \item Type: Type of feature, CDS,tRNA,rRNA,misc_feature, or D-loop.
#'   \item Name: Name of synonym for a feature to search for.
#' }
#' 
#' @seealso \code{\link{MergeSearchTerms}}
"mtDNAterms"

#' Mitochondrial DNA Search Terms for Plants
#'
#' A data frame containing search terms for plant mitochondrial loci. Can be subset for loci of 
#'  interest. Columns are as follows and users should follow the column format if they wish to
#'  add search terms using the MergeSearchTerms function:
#'
#' @format A data frame of of 248 rows and 3 columns
#' \itemize{
#'   \item Feature: Feature name, FASTA files will be written with this name.
#'   \item Type: Type of feature, either CDS,tRNA,rRNA.
#'   \item Name: Name of synonym for a feature to search for.
#' }
#' 
#' @seealso \code{\link{MergeSearchTerms}}
"mtDNAtermsPlants"

#' Chloroplast DNA (cpDNA) Search Terms
#'
#' A data frame containing search terms for Chloroplast loci. Can be subset for loci of 
#'  interest. Columns are as follows and users should follow the column format if they wish to
#'  add search terms using the MergeSearchTerms function:
#'
#' @format A data frame of of 391 rows and 3 columns
#' \itemize{
#'   \item Feature: Feature name, FASTA files will be written with this name.
#'   \item Type: Type of feature, either CDS,tRNA,rRNA.
#'   \item Name: Name of synonym for a feature to search for.
#' }
#' 
#' @seealso \code{\link{MergeSearchTerms}}
"cpDNAterms"

#' Ribosomal DNA (rDNA) Search Terms
#'
#' A data frame containing search terms for ribosomal RNA loci. Can be subset for loci of 
#'  interest. Columns are as follows and users should follow the column format if they wish to
#'  add search terms using the MergeSearchTerms function:
#'
#' @format A data frame of of 14 rows and 3 columns
#' \itemize{
#'   \item Feature: Feature name, FASTA files will be written with this name.
#'   \item Type: Type of feature, either rRNA or misc_RNA.
#'   \item Name: Name of synonym for a feature to search for.
#' }
#' 
#' @seealso \code{\link{MergeSearchTerms}}
"rDNAterms"

#' Find the longest sequence for each species from a list of GenBank accession numbers.
#' @param Accessions A vector of GenBank accession numbers.
#' @param BatchSize Numeric. If the number of accessions is over the number provided, requests will be sent in batches of this amount. This is necessary for the NCBI servers. If you receive an HTTP 414 error, try to reduce the size of the batch. Default is 300.
#' @details For a set of GenBank accession numbers, this will return the longest sequence for in the set for species.
#' @return A list of genbank accessions numbers for the longest sequence for each taxon in a list of accession numbers.
#' @examples 
#' #a vector of 4 genbank accessions, there are two accessions for each species.
#' genbank.accessions<-c("KP978059.1","KP978060.1","JX516105.1","JX516111.1")
#' @examplesIf interactive()
#' #returns the longest sequence respectively for the two species.
#' long.seq.result <- FindLongestSeq(genbank.accessions)
#' @export

FindLongestSeq <- function(Accessions, BatchSize = 300){
  BatchAccessions <- length(Accessions)#Calc the length of the accessions for batching checks
  if(BatchAccessions > BatchSize){#If accessions is more than the batch size, batch
    BatchRequests <- split(Accessions, ceiling(seq_along(Accessions)/BatchSize))#split into batches by batch size
  }else{
    BatchRequests <- list(Accessions)#single batch if less than BatchSize threshold, but as list to reduce code to work on one or more batches
  }
  
  BatchResults <- list()#Make an empty list to stor the batches
  
  for (BatchIndex in 1:length(BatchRequests)) {#For each batch of sequences
    #Obtain summaries for the current batch while checking for errors
    BatchSummary <- tryCatch({
      rentrez::entrez_summary(db = "nuccore", id = BatchRequests[[BatchIndex]])
    }, error = function(e) {
      message(paste("Error in batch", BatchIndex, ":", e$message))
      return(NULL)
    }
    )
    if (!is.null(BatchSummary)) {#If BatchSummary is non-null
      batch_df <- data.frame(
        Species = gsub(pattern = " ", replacement = "_", rentrez::extract_from_esummary(BatchSummary, "organism")),#extract organism name
        Accession = rentrez::extract_from_esummary(BatchSummary, "caption"),#Extract Accession Numbers
        Length = rentrez::extract_from_esummary(BatchSummary, "slen"),#Extract sequence langth
        stringsAsFactors = FALSE
      )
      BatchResults[[BatchIndex]] <- batch_df# Store the batch in list

    }
    Sys.sleep(0.5)#Sleep between batches to not violate NCBI terms and conditions 
  }
  FinalSequences <- do.call(rbind, BatchResults)#Bind batches together.
  
  uni.taxa <- unique(FinalSequences$Species)#get unique taxa
  long.seqs <- data.frame(matrix(nrow=length(uni.taxa), ncol=dim(FinalSequences)[2]))#empty data frame to store results
  colnames(long.seqs) <- colnames(FinalSequences)#make column names to match
  
  for (taxa.index in 1:length(uni.taxa)){#for each taxa
    current.tax <- subset(FinalSequences, FinalSequences$Species==uni.taxa[taxa.index])#subset the sequences for that species
    longest.seq <- subset(current.tax,current.tax$Length==sort(as.numeric(current.tax$Length),decreasing = TRUE)[1])[1,]#id and grab longest seq for that species
    long.seqs[taxa.index, ] <- longest.seq#append data frame with longest seq
  }
  return(long.seqs)#Return final dataframe with longest sequences
}

#' An R package to extract sub-sequences from GenBank annotations under different synonyms
#'
#' @description An R package to extract sub-sequences from GenBank annotations under different synonyms.
#'
#' @details 
#' Package: AnnotationBustR
#' 
#' Type: Package
#' 
#' Title: An R package to extract sub-sequences from GenBank annotations under different synonyms
#' 
#' Version: 2.0
#' 
#' Date: 2026-6-16
#' 
#' License: GPL (>= 2)
#' 
#' This package allows users to quickly extract sub-sequences from GenBank accession numbers that may be annotated
#' under different synonyms. It writes these sub-sequences to FASTA files and creates a corresponding accession
#' table. The package comes with pre-made search terms with synonyms. A vignette going over the basic functions and
#' how to use them can be accessed with vignette("AnnotationBustR-vignette").
#' 
#' @author Samuel Borstein, Brian O'Meara.
#' Maintainer: Samuel Borstein <sam@borstein.com>
#' 
#' @seealso \code{\link{AnnotationBust}},\code{\link{cpDNAterms}},\code{\link{FindLongestSeq}},\code{\link{MergeSearchTerms}},\code{\link{mtDNAterms}},\code{\link{rDNAterms}}
#' 
#' @name AnnotationBustR
#"_PACKAGE"
#> [1] "_PACKAGE"
NULL

---
title: "AnnotationBustR Tutorial"
author: "Samuel R. Borstein"
date: "`r format(Sys.time(), '%d %B, %Y')`"
output:
  html_document:
    keep_md: true
vignette: >
  %\VignetteIndexEntry{AnnotationBustR Tutorial}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

# 1: Introduction

This is a tutorial for using version 2.0 and up of the R package `AnnotationBustR`. `AnnotationBustR` reads in sequences from GenBank and allows you to quickly extract specific parts and write them to FASTA files given a set of search terms. This is useful as it allows users to quickly extract parts of concatenated or genomic sequences based on GenBank features and write them to FASTA files, even when feature annotations for homologous loci may vary (i.e. gene synonyms like COI, COX1, COXI all being used for cytochrome oxidase subunit 1).

In this tutorial we will discuss some new changes to `AnnotationBustR`, cover the basics of how to use `AnnotationBustR` to extract parts of a GenBank sequences.This is considerably faster than  extracting them manually and requires minimal effort by the user. While command line utilities like BLAST can also work, they require the building of databases to search against and can be computationally intensive and can have difficulties with highly complex sequences, like trans-spliced genes. They also require a far more complex query language to extract the subsequence and write it to a file. For example, it is possible to extract into FASTA files every subsequence from a mitochondrial genome (38 sequences, 13 CDS, 22 tRNA, 2rRNA, 1 D-loop) in  15-30 seconds, which is significantly faster than if you were to do it manually from the online GenBank features table. In this tutorial, we will discuss how to install `AnnotationBustR`, the basic `AnnotationBustR` pipeline, and how to use the functions that are included in `AnnotationBustR`.

# 2: What's new in AnnotationBustR 2.0+

## 2.1: New Dependencies Provide Up To Date Access, New Features, and Stability
This new version of `AnnotationBustR` is a complete rewrite of `AnnotationBustR`. Notably, `AnnotationBustR 2.0+` now uses various `Bioconductor` dependencies to extract subsequences. Previously, `AnnotationBustR` accessed subsequences through the ACNUC via the package `seqinr`. There are several reasons for this change:

1. The GenBank version accessed by `seqinr` is quite out of date. We can see that the version of GenBank being used by ACNUC in `seqinr` is from 2021. Thus, newer accessions were not accessible in `AnnotationBustR`. We can see this by running the following:

```
ACNUC.GB.INFO <- seqinr::choosebank("genbank", infobank=T)
ACNUC.GB.INFO#return info on date
``` 

2. Several users reported connectivity issues, specifically with connecting to ACNUC via `seqinr` getting server connection issues or having their connection dropped with the ACNUC server. We now retrieve accessions from NCBI directly through  the `rentrez` package, which is more stable.

3. ACNUC via `seqinr` did not always provide access to certain refseq sequences. These are now accessible in the current version written with `rentrez` and various `Bioconductor` packages.

4. ACNUC had its own predefined tags for feature subsequences. The new version of `AnnotationBustR` now parses GenBank feature files directly, allowing for a more flexible capture of potential feature types.

## 2.2: Other Minor New Features

1. Users no longer have to provide a translation code when requesting coding sequences be translated.

2. Users can now request coding sequences to be returned as DNA or the translated sequence or both.

3. Accession tables written by AnnotationBustR now contain a citation for the generation of sequence data, allowing users to properly cite and give credit to the researchers who generated the sequence.


# 3: Installation
## 3.1: Installation From CRAN
In order to install the stable CRAN version of the AnnotationBustR package:
```
install.packages("AnnotationBustR")
```
## 3.2: Installation of Development Version From GitHub
While we recommend use of the stable CRAN version of this package, you can use the R package `pak` to install the development version of the package from GitHub if for any reason you wish to use it :
```
#1. Install 'devtools' if you do not already have it installed:
install.packages("devtools")

#2. Load the 'devtools' package and install the development version of
#'AnnotationBustR' from GitHub:
library(devtools)
pak::pak("sborstein/AnnotationBustR")  # install the package from GitHub
library(AnnotationBustR)# load the package

```
# 4: Using AnnotationBustR
To load AnnotationBustR and all of its functions/data:
```
library(AnnotationBustR)
```
It is important to note that most of the functions within `AnnotationBustR` connect to sequence databases and require an internet connection.

##4.0: AnnotationBustR Work Flow
Before we begin a tutorial on how to use AnnotationBustR to extract sequences, lets first discuss the basic workflow of the functions in the package (Fig. 1). The orange box represents the step that occur outside of using `AnnotationBustR`. The only step you must do outside of `AnnotationBustR` is obtain a target list of accession numbers. This can be done either by downloading the accession numbers themselves from GenBank (https://www.ncbi.nlm.nih.gov/nuccore) or using R packages like `ape`, `seqinr` and `rentrez` to find accessions of interest in R. All boxes in blue in the graphic below represent steps that occur using `AnnotationBustR`. Boxes in green represent steps that are not mandatory, but may prove to be useful features of `AnnotationBustR`. In this tutorial, we will go through the steps in order, including the optional steps to show how to fully use the AnnotationBustR package.


```{r, out.width = "100%", echo=FALSE,fig.align='left',fig.cap= "Fig. 1: AnnotationBustR Workflow. Steps in orange occur outside the package while steps in blue are core parts of AnnotationBustR and steps in green represent optional steps"}
knitr::include_graphics("workflow.jpg")
```

For this tutorial we will be extracting loci from the mitochondrial genomes of a fish genus, *Barbonymus*. We'll start off by using the R package `reutils` to search for accessions to use in this tutorial. There are a variety of R packages that can be used to find accessions you may want to extract subsequences from (i.e. `seqinr`,`rentrez`,`reutils`) or you can perform a search on the NCBI Database website (https://www.ncbi.nlm.nih.gov/nuccore) and download a list of accession numbers that can then be read into R.

```
#install (if necessary) and load reutils
#install.packages("rentrez")#install if necessary
library(rentrez)
```
Lets pretend we wanted to search for mitochondrial genomes. We could perform a search using the following.
```
#search for Barbonymus mitogenome sequences
demo.search <- rentrez::entrez_search(db = "nuccore",  term = "Barbonymus[orgn] AND complete genome[title]", use_history = TRUE)#search
accessions <- rentrez::entrez_fetch(db = "nuccore", web_history = demo.search$web_history, rettype = "acc")#fetch accessions
accessions <- strsplit(accessions, "\n")[[1]]#split out accessions from new line characters
```
We can see that this returns ten complete mitochondrial genome sequences from GenBank for *Barbonymus* species. We'll be using these accessions later in this tutorial.


## 4.1:(Optional Step) Finding the Longest Available
AnnotationBustR's `FindLongestSeq` function finds the longest available sequence for each species in a given set of GenBank accession numbers. All the user needs is to obtain a list of GenBank accession numbers they would like to input. The only function argument for `FindLongestSeq` is `Accessions`, which takes a vector of accession numbers as input. We can run the function below on the six Barbonymus accessions we found above by:

```
#Create a vector of GenBank nucleotide accession numbers. In order this contains accessions 
my.longest.seqs<-FindLongestSeq(accessions)#Run the FindLongestSeq function
my.longest.seqs#returns the longest seqs found per species
```
In this case we can see that the function worked as it only returned accession PP937076 (16577 bp) for *Barbonymus schwanefeldii* which was longer than accessions AP011317.1, KU498040.2, KU233186.2, KJ573467.1  (16577, 16570,16478, and 16576 bp respectively) as well as the single accessions for *Barbonymus altus* and *Barbonymus gonionnotus*. The table returns a three-column data frame with the species name, the corresponding accession number, and the length.

## 4.2: Load a Data Frame of Search Terms of Gene Synonyms to Search With:
`AnnotationBustR` works by searching through the annotation features table for a feature of interest using search terms for it (i.e. possible synonyms it may be listed under). These search terms are formatted to have three columns:

- Feature: The name you wish to refer to for a feature. This also controls the names of the FASTA files written for when that feature is extracted. It is important that you use names that will not confuse R, so don't start these with numbers or include other characters like "." or "-" that R uses for math.
- Type: The type of sequence to search for. For example, CDS, tRNA, rRNA, misc_RNA, D-Loop, or misc_feature to name a few. Features are parsed in `AnnotationBustR` dynamically, so any feature type should be extractable.
- Name: A possible synonym that the feature could be listed under that you wish to search for.

For extracting introns and exons, an additional fourth column is needed (which will be discussed in more detail later in the tutorial):
-IntronExonNumber: The number of the intron or exon to extract (e.g. intron 2). 

Below (Figure 2) is an example of where these corresponding items would be in the GenBank features table:
```{r, out.width = "100%", echo=FALSE, fig.align='left',fig.cap= "Fig. 2: GenBank features annotation for accession G295784.1 that contains ATP8 and ATP6. The words highlighted in yellow would fall under the column of Type. Here they are both CDS. The type of sequence is always listed farthest to the left in the features table. Colors in blue indicate terms that would be placed in the Name column, here indicating that the two CDS in this example are ATP8, labeled as ATPase8 and ATP6 respectively."}
knitr::include_graphics("featuresMarked.jpg")
```

So, if we wanted to use AnnotationBustR to capture these and write them to a FASTA, we could set up a data frame that looks like the following.
```{r, echo=FALSE}
ex.frame <- rbind(c("ATP8","CDS","ATPase8"),c("ATP6","CDS","ATPase6"))
colnames(ex.frame) <- c("Feature","Type","Name")
ex.frame <- as.data.frame(ex.frame)
print(ex.frame)
```

While AnnotationBustR will work with any data frame formatted as discussed above, we have included in it pre-made search terms for animal and plant mitochondrial DNA (mtDNA), chloroplast DNA (cpDNA), and ribosomal DNA (rDNA). These can be loaded from AnnotationBustR using:

```
#Load in pre-made data frames of search terms
data(mtDNAterms)#loads the mitochondrial DNA search terms for metazoans
data(mtDNAtermsPlants)#loads the mitochondrial DNA search terms for plants
data(cpDNAterms)#loads the chloroplast DNA search terms
data(rDNAterms)#loads the ribosomal DNA search terms
```
These data frames can also easily be manipulated to select only the loci of interest. For instance, if we were only interested in tRNAs from mitochondrial genomes, we could easily subset out the tRNAs from the premade `mtDNAterms` object by:

```
data(mtDNAterms)#load the data frame of mitochondrial DNA terms
tRNA.terms <- mtDNAterms[mtDNAterms$Type=="tRNA",]#subset out the tRNAs into a new data frame
```

## 4.3:(Optional Step) Merge Search Terms If Neccessary

While we have tried to cover as many synonyms for genes in our pre-made data frames, it is likely that some synonyms may not be represented due to the vast array of synonyms a single gene may be listed under in the features table. To solve this we have included the function `MergeSearchTerms`.

For example, let's imagine that we found a completely new annotation for the gene cytochrome oxidase subunit 1 (COI) listed as CX1. The `MergeSearchTerms` function only has two arguments, `...`, which takes two or more objects of class `data.frame` and  the logical `Sort.Genes`, which We could easily add this to other mitochondrial gene terms by:

```
#Add imaginary gene synonym for cytochrome oxidase subunit 1, CX1
add.name <- data.frame("COI","CDS", "CX1", stringsAsFactors = FALSE)
colnames(add.name) <- colnames(mtDNAterms)#make the columnames for this synonym those needed for AnnotationBustR

#Run the merge search term function without sorting based on gene name.
new.terms <- MergeSearchTerms(add.name, mtDNAterms, SortGenes=FALSE)

#Run the merge search term function with sorting based on gene name.
new.terms <- MergeSearchTerms(add.name, mtDNAterms, SortGenes=TRUE)
```
We will use this function again in a more realistic example later in this vignette.

## 4.4 Extract sequences with AnnotationBust
The main function of AnnotationBustR is `AnnotationBust`. This function extracts the sub-sequence(s) of interest from the accessions and writes them to FASTA files in the current working directory. In addition to writing sub-sequences to FASTA files, `AnnotationBust` also generates an accession table for all found sub-sequences written to FASTA files which can then be written to a csv file using base R `write.csv`. AnnotationBustR requires at least two arguments, a vector of accessions for `Accessions` and a data frame of search terms formatted as discussed in 3.2 and 3.3 for `Terms`.

Additional arguments include the ability to specify duplicate genes you wish to recover as a vector of gene names using the `Duplicates` argument and specifying the number of duplicate instances to extract using a numeric vector (which must be the same length as `Duplicates`) using the `DuplicateInstances` argument.

AnnotationBustR also has arguments to translate coding sequences into the corresponding peptide sequence setting the `TranslateSeqs` argument to TRUE. If `TranslateSeqs=TRUE`, users should also specify the GenBank translation code number corresponding to their sequences using the `TranslateCode` argument. A list of GenBank translaton codes for taxa is available here: https://www.ncbi.nlm.nih.gov/Taxonomy/Utils/wprintgc.cgi

An additional argument of `AnnotationBust` is `DuplicateSpecies` which when set to `DuplicateSpecies=TRUE` adds the accession number to the species name for the FASTA file. This can be useful for later analyses involving FASTA files as duplicate names in FASTA headers can pose problems with some programs. It is important to note that if users select `DuplicateSpecies=TRUE` that while FASTA file will contain species names with their respected accession number, the corresponding accession table will either have a single row per species containing all the accession numbers for each subsequence locus found for that species seperated by a comma or a seperate row for each accession number dependent on what the user chooses for the `TidyAccessions` argument (see description below).

The argument `Prefix`can either be `NULL` or a character vector of length 1. If Prefix is not `NULL` it will add the prefix specified to all FASTA files. If left as `Prefix=NULL` files names will just be the name of the locus.

The final argument `TidyAccessions` effects the format of the final accession table. If `TidyAccessions=TRUE`, all sequence for a single species will be collapsed into a single cell per locus and accessions will be seperated by commas. If `TidyAccessions=FALSE` it will leave each accession number in its own row in the accession table. 

For the tutorial, we will use the accessions we created in examples 3.1 in the object `my.longest.accessions`. This is a vector that contains three accessions for mitogenomes of three species of *Barbonymus*. These accessions provide a good highlight as to the utility of this package.If we look at the annotations of these three accessions(https://www.ncbi.nlm.nih.gov/nuccore/AP011317.1,https://www.ncbi.nlm.nih.gov/nuccore/AP011181.1,https://www.ncbi.nlm.nih.gov/nuccore/AB238966.1), we can see that while AP011317 and AP011181 are annotated with similar nomenclature, AB238966 differs substantially (e.x. COI vs CO2, Cyt b vs Cb, etc.). For this example, we will use all the arguments of `AnnotationBust` to extract all 38 subsequences for the four accessions (22 tRNAs, 13 CDS, 2 rRNAs, and 1 D-loop). For this we will have to specify duplicates, in this case for tRNA-Leu and tRNA-Ser, which occur twice in vertebrate mitogenomes. We will translate the CDS using `TranslateSeqs = "Both"` to return both the DNA and peptide sequence. Because we have a single accession for each species, we will specify `DuplicateSpecies=FALSE` and have out FASTA files output with the prefix "Demo" by specifying `Prefix="Demo"` and with `TiddyAccessions=TRUE`. This will create 38 FASTA files for all mitochondrial loci in the mitochondrial genome in the working director with the prefix "Demo".

```
#run AnnotationBust function for two duplicate tRNA genes occuring twice and translate CDS
my.seqs <- AnnotationBust(Accessions=my.longest.seqs$Accession, Terms=mtDNAterms,Duplicates=c("tRNA_Leu","tRNA_Ser"), DuplicateInstances=c(2,2), TranslateSeqs="Both", DuplicateSpecies=TRUE, Prefix="Demo", TidyAccessions=TRUE)

#We can return the accession table and write it to a CSV file.
my.seqs#retutn the accession table
write.csv(my.seqs, file="AccessionTable.csv")#Write the accession table to a csv file
```

We can also use `AnnotationBustR` to extract introns from sequences. One limitation to this is that the introns must be annotated within the subsequence, which is lacking from some accessions (e.x. not all chloroplasts have introns annotated). As stated above, this requires the use of a fourth column in the search terms, labelled `IntronExonNumber`, which is used to find which number intron is to be extracted. For instance, lets imagine we want to extract the coding sequence matK and exon 2 and intron 1 of trnK from the chloroplast genomes KX687911.1 and KX687910.1 We could set up the search terms as follows using the current `cpDNAterms`:

```
#Subset out matK from cpDNAterms
cds.terms <- subset(cpDNAterms,cpDNAterms$Feature=="matK")
#Create a vecotr of NA so we can merge with the search terms for introns and exons
cds.terms <- cbind(cds.terms,(rep(NA,length(cds.terms$Feature))))
colnames(cds.terms)[4] <- "IntronExonNumber"

#Prepare a search term table for the intron and exons to remove
#We can start with the cpDNAterms for trnK
IntronExon.terms <- subset(cpDNAterms,cpDNAterms$Feature=="trnK")
#As we want to go for two exons, we will want the synonyms repeated as we are doing and intron and an exon
IntronExon.terms <- rbind(IntronExon.terms,IntronExon.terms)#duplicate the terms
IntronExon.terms$Type <- rep(c("intron","intron","exon","exon"))#rep the sequence type we want to extract
IntronExon.terms$Feature <- rep(c("trnK_Intron","trnK_Exon2"),each=2)
IntronExon.terms <- cbind(IntronExon.terms,rep(c(1,1,2,2)))#Add intron/exon number info
colnames(IntronExon.terms)[4] <- "IntronExonNumber"#change column name for number info for IntronExon name

#We can then merge everything together with MergeSearchTerms terms
IntronExonExampleTerms <- MergeSearchTerms(IntronExon.terms,cds.terms)

#Run AnnotationBust
IntronExon.example <- AnnotationBust(Accessions=c("KX687911.1", "KX687910.1"), Terms=IntronExonExampleTerms, Prefix="DemoIntronExon")
```
## 4.5 Troubleshooting
As `AnnotationBustR` is dependent on access to online databases, it is important that you make sure you have a reliable internet connection while using the package, especially for the `FindLongestSeq` and `AnnotationBust` functions. Additionally, as these functions require access to NCBI, if you have internet access yet are still having issues, check that these sites and there servers are not down or undergoing maintenance, which they do occasionally. For `AnnotationBust`, you will get the following`Could not connect to NCBI` message printed to the screen in the event that it cannot connect to the NCBI database.

The `AnnotationBust` function may also provide the following warnings and messages as well as report the following in the accessions table:

`Working On Accession 1 of 1: ACCESSION# not found on NCBI`. This indicates that the accession number was not found on NCBI. You should check that it is correct and exists. This will also fill in the accession table with `Failed to find ACCESSION#`. Here, `ACCESSION#` will be the actual accession.


# 5: Final Comments
Further information on the functions and their usage can be found in the helpfiles `help(package=AnnotationBustR)`. For any further issues and questions send an email with subject 'AnnotationBustR support' to borstein@txstate.edu or post to the issues section on GitHub(https://github.com/sborstein/AnnotationBustR/issues).

---
title: "AnnotationBustR Tutorial"
author: "Samuel R. Borstein"
date: "`r format(Sys.time(), '%d %B, %Y')`"
output:
  html_document:
    keep_md: true
vignette: >
  %\VignetteIndexEntry{AnnotationBustR Tutorial}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

# 1: Introduction

This is a tutorial for using the R package AnnotationBustR. AnnotationBustR reads in sequences from GenBank and allows you to quickly extract specific parts and write them to FASTA files given a set of search terms. This is useful as it allows users to quickly extract parts of concatenated or genomic sequences based on GenBank features and write them to FASTA files, even when feature annotations for homologous loci may vary (i.e. gene synonyms like COI, COX1, COXI all being used for cytochrome oxidase subunit 1).

In this tutorial we will cover the basics of how to use AnnotationBustR to extract parts of a GenBank sequences.This is considerably faster than  extracting them manually and requires minimal effort by the user. While command line utilities like BLAST can also work, they require the buliding of databases to search against and can be computationally intensive and can have difficulties with highly complex sequences, like trans-spliced genes. They also require a far more complex query language to extract the subsequence and write it to a file. For example, it is possible to extract into FASTA files every subsequence from a mitochondrial genome (38 sequences, 13 CDS, 22 tRNA, 2rRNA, 1 D-loop) in  26-36 seconds, which is significantly faster than if you were to do it manually from the online GenBank features table. In this tutorial, we will discuss how to install AnnotationBustR, the basic AnnotationBustR pipeline, and how to use the functions that are included in AnnotationBustR.

# 2: Installation
## 2.1: Installation From CRAN
In order to install the stable CRAN version of the AnnotationBustR package:
```
install.packages("AnnotationBustR")
```
## 2.2: Installation of Development Version From GitHub
While we recommend use of the stable CRAN version of this package, we recommend using the package `devtools` to temporarily install the development version of the package from GitHub if for any reason you wish to use it :
```
#1. Install 'devtools' if you do not already have it installed:
install.packages("devtools")

#2. Load the 'devtools' package and temporarily install the development version of
#'AnnotationBustR' from GitHub:
library(devtools)
dev_mode(on=T)
install_github("sborstein/AnnotationBustR")  # install the package from GitHub
library(AnnotationBustR)# load the package

#3. Leave developers mode after using the development version of 'AnnotationBustR' so it will not remain on 
#your system permanently.
dev_mode(on=F)
```
# 3: Using AnnotationBustR
To load AnnotationBustR and all of its functions/data:
```
library(AnnotationBustR)
```
It is important to note that most of the functions within AnnotationBustR connect to sequence databases and require an internet connection.

##3.0: AnnotationBustR Work Flow
Before we begin a tutorial on how to use AnnotationBustR to extract sequences, lets first discuss the basic workflow of the functions in the package (Fig. 1). The orange box represents the step that occur outside of using AnnotationBustR. The only step you must do outside of AnnotationBustR is obtain a target list of accession numbers. This can be done either by downloading the accession numbers themselves from GenBank (https://www.ncbi.nlm.nih.gov/nuccore) or using R packages like `ape`, `seqinr` and `rentrez` to find accessions of interest in R. All boxes in blue in the graphic below represent steps that occur using AnnotationBustR. Boxes in green represent steps that are not mandatory, but may prove to be useful features of AnnotationBustR. In this tutorial, we will go through the steps in order, including the optional steps to show how to fully use the AnnotationBustR package.


```{r, out.width = "100%", echo=FALSE,fig.align='left',fig.cap= "Fig. 1: AnnotationBustR Workflow. Steps in orange occur outside the package while steps in blue are core parts of AnnotationBustR and steps in green represent optional steps"}
knitr::include_graphics("workflow.jpg")
```

For this tutorial we will be extracting loci from the mitochondrial genomes of a fish genus, *Barbonymus*. We'll start off by using the R package `reutils` to search for accessions to use in this tutorial. There are a variety of R packages that can be used to find accessions you may want to extract subsequences from (i.e. `seqinr`,`rentrez`,`reutils`) or you can perform a search on the NCBI Database website (https://www.ncbi.nlm.nih.gov/nuccore) and download a list of accession numbers that can then be read into R.

```
#install (if necessary) and load reutils
#install.packages("reutils")#install if necessary
library(reutils)
```
Lets pretend we wanted to search for the gene cytochrome B. We could perform a search using the following.
```
#search for cytochrome b Barbonymus sequences
demo.search <- esearch(term = "Barbonymus[orgn] and CYTB[title]", db = 'nuccore', usehistory = TRUE)#search
accessions<-efetch(demo.search, rettype = "acc",retmode = "text")#fetch accessions
accessions <- strsplit(content(accessions), "\n")[[1]]#split out accessions from other meta-data
```
We can see that this returned 51 sequences. Many of these are accessions for a single cytochrome b sequence. However, if we wanted to find complete mitochondrial genomes to extract sequences from, we could refine our search to find complete mitochondrial genomes.
```
#perform the search and retrieve accessions of complete mitochondrial genomes for Barbonymus
demo.search <- esearch(term = "Barbonymus[orgn] and complete genome[title]", db = 'nuccore')#search
accessions<-efetch(demo.search, rettype = "acc",retmode = "text")#fetch accessions
accessions <- strsplit(content(accessions), "\n")[[1]]#split out accessions from other meta-data
#Currently, ACNUC, which AnnotationBustR uses through the seqinr dependency, doesn't have access to refseq 
#accessions, so remove them
accessions<-accessions[-grep("NC_",accessions)]
```
We can see that this returns six complete mitochondrial genome sequences on GenBank for *Barbonymus* species. We'll be using these accessions later in this tutorial.

One important note for using `reutils` for finding sequences is that if you are trying to retrieve over 500 accession numbers, you will get a warning that you need to write it to a file locally on the machine. In this case, you can use the folowing code below. As the file is local and not stored in R, you will need to read it back into R for use with AnnotationBustR. Luckily, this doesn't write meta-data to the file, so we don't have to run the line stripping the meta-data.

```
#Perform search given critera
demo.search.long <- esearch(term = "Pristimantis[orgn] and 12S[title]", db = 'nuccore', usehistory = TRUE) 
#As more than 500 records, write the records to file in the current working directory
accessions.long<-efetch(demo.search.long, rettype = "acc",retmode  = "text", outfile = "12S.txt")
#Read in file with records, you can now use these in AnnotationBustR
accessions.long.table <- read.table("12S.txt",header = FALSE,stringsAsFactors = FALSE) 
accessions.long.accessions <- accessions.long.table$V1
```

## 3.1:(Optional Step) Finding the Longest Available
AnnotationBustR's `FindLongestSeq` function finds the longest available sequence for each species in a given set of GenBank accession numbers. All the user needs is to obtain a list of GenBank accession numbers they would like to input. The only function argument for `FindLongestSeq` is `Accessions`, which takes a vector of accession numbers as input. We can run the function below on the six Barbonymus accessions we found above by:

```
#Create a vector of GenBank nucleotide accession numbers. In order this contains accessions 
my.longest.seqs<-FindLongestSeq(accessions)#Run the FindLongestSeq function
my.longest.seqs#returns the longest seqs found per species
```
In this case we can see that the function worked as it only returned accession AP011317.1 (16577 bp) for *Barbonymus schwanefeldii* which was longer than accessions KU498040.2, KU233186.2, KJ573467.1  (16570,16478, and 16576 bp respectively) as well as the single accessions for *Barbonymus altus* and *Barbonymus gonionnotus*. The table returns a three-column data frame with the species name, the corresponding accession number, and the length.

## 3.2: Load a Data Frame of Search Terms of Gene Synonyms to Search With:
AnnotationBustR works by searching through the annotation features table for a locus of interest using search terms for it (i.e. possible synonyms it may be listed under). These search terms are formatted to have three columns:

- Locus: The name of the locus and the name of the FASTA of the file for that locus to be written. It is important that you use names that will not confuse R, so don't start these with numbers or include other characters like "." or "-" that R uses for math.
- Type: The type of sequence to search for. Can be one of CDS, tRNA, rRNA, misc_RNA, D-Loop, or misc_feature.
- Name: A possible synonym that the locus could be listed under.

For extracting introns and exons, an additional fourth column is needed (which will be discussed in more detail later in the tutorial):
-IntronExonNumber: The number of the intron or exon to extract

Below (Figure 2) is an example of where these corresponding items would be in the GenBank features table:
```{r, out.width = "100%", echo=FALSE, fig.align='left',fig.cap= "Fig. 2: GenBank features annotation for accession G295784.1 that contains ATP8 and ATP6. The words highlighted in yellow would fall under the column of Type. Here they are both CDS. The type of sequence is always listed farthest to the left in the features table. Colors in blue indicate terms that would be placed in the Name column, here indicating that the two CDS in this example are ATP8, labeled as ATPase8 and ATP6 respectively."}
knitr::include_graphics("featuresMarked.jpg")
```

So, if we wanted to use AnnotationBustR to capture these and write them to a FASTA, we could set up a data frame that looks like the following.
```{r, echo=FALSE}
ex.frame<-rbind(c("ATP8","CDS","ATPase8"),c("ATP6","CDS","ATPase6"))
colnames(ex.frame)<-c("Locus","Type","Name")
ex.frame<-as.data.frame(ex.frame)
print(ex.frame)
```

While AnnotationBustR will work with any data frame formatted as discussed above, we have included in it pre-made search terms for animal and plant mitochondrial DNA (mtDNA), chloroplast DNA (cpDNA), and ribosomal DNA (rDNA). These can be loaded from AnnotationBustR using:

```
#Load in pre-made data frames of search terms
data(mtDNAterms)#loads the mitochondrial DNA search terms for metazoans
data(mtDNAtermsPlants)#loads the mitochondrial DNA search terms for plants
data(cpDNAterms)#loads the chloroplast DNA search terms
data(rDNAterms)#loads the ribosomal DNA search terms
```
These data frames can also easily be manipulated to select only the loci of interest. For instance, if we were only interested in tRNAs from mitochondrial genomes, we could easily subset out the tRNAs from the premade `mtDNAterms` object by:

```
data(mtDNAterms)#load the data frame of mitochondrial DNA terms
tRNA.terms<-mtDNAterms[mtDNAterms$Type=="tRNA",]#subset out the tRNAs into a new data frame
```

## 3.3:(Optional Step) Merge Search Terms If Neccessary

While we have tried to cover as many synonyms for genes in our pre-made data frames, it is likely that some synonyms may not be represented due to the vast array of synonyms a single gene may be listed under in the features table. To solve this we have included the function `MergeSearchTerms`.

For example, let's imagine that we found a completely new annotation for the gene cytochrome oxidase subunit 1 (COI) listed as CX1. The `MergeSearchTerms` function only has two arguments, `...`, which takes two or more objects of class `data.frame` and  the logical `Sort.Genes`, which We could easily add this to other mitochondrial gene terms by:

```
#Add imaginary gene synonym for cytochrome oxidase subunit 1, CX1
add.name<-data.frame("COI","CDS", "CX1", stringsAsFactors = FALSE)
colnames(add.name)<-colnames(mtDNAterms)#make the columnames for this synonym those needed for AnnotationBustR

#Run the merge search term function without sorting based on gene name.
new.terms<-MergeSearchTerms(add.name, mtDNAterms, SortGenes=FALSE)

#Run the merge search term function with sorting based on gene name.
new.terms<-MergeSearchTerms(add.name, mtDNAterms, SortGenes=TRUE)
```
We will use this function again in a more realistic example later in this vignette.

## 3.4 Extract sequences with AnnotationBust
The main function of AnnotationBustR is `AnnotationBust`. This function extracts the sub-sequence(s) of interest from the accessions and writes them to FASTA files in the current working directory. In addition to writing sub-sequences to FASTA files, `AnnotationBust` also generates an accession table for all found sub-sequences written to FASTA files which can then be written to a csv file using base R `write.csv`. AnnotationBustR requires at least two arguments, a vector of accessions for `Accessions` and a data frame of search terms formatted as discussed in 3.2 and 3.3 for `Terms`.

Additional arguments include the ability to specify duplicate genes you wish to recover as a vector of gene names using the `Duplicates` argument and specifying the number of duplicate instances to extract using a numeric vector (which must be the same length as `Duplicates`) using the `DuplicateInstances` argument.

AnnotationBustR also has arguments to translate coding sequences into the corresponding peptide sequence setting the `TranslateSeqs` argument to TRUE. If `TranslateSeqs=TRUE`, users should also specify the GenBank translation code number corresponding to their sequences using the `TranslateCode` argument. A list of GenBank translaton codes for taxa is available here: https://www.ncbi.nlm.nih.gov/Taxonomy/Utils/wprintgc.cgi

An additional argument of `AnnotationBust` is `DuplicateSpecies` which when set to `DuplicateSpecies=TRUE` adds the accession number to the species name for the FASTA file. This can be useful for later analyses involving FASTA files as duplicate names in FASTA headers can pose problems with some programs. It is important to note that if users select `DuplicateSpecies=TRUE` that while FASTA file will contain species names with their respected accession number, the corresponding accession table will either have a single row per species containing all the accession numbers for each subsequence locus found for that species seperated by a comma or a seperate row for each accession number dependent on what the user chooses for the `TidyAccessions` argument (see description below).

The argument `Prefix`can either be `NULL` or a character vector of length 1. If Prefix is not `NULL` it will add the prefix specified to all FASTA files. If left as `Prefix=NULL` files names will just be the name of the locus.

The final argument `TidyAccessions` effects the format of the final accession table. If `TidyAccessions=TRUE`, all sequence for a single species will be collapsed into a single cell per locus and accessions will be seperated by commas. If `TidyAccessions=FALSE` it will leave each accession number in its own row in the accession table. 

For the tutorial, we will use the accessions we created in examples 3.1 in the object `my.longest.accessions`. This is a vector that contains three accessions for mitogenomes of three species of *Barbonymus*. These accessions provide a good highlight as to the utility of this package.If we look at the annotations of these three accessions(https://www.ncbi.nlm.nih.gov/nuccore/AP011317.1, https://www.ncbi.nlm.nih.gov/nuccore/AP011181.1, https://www.ncbi.nlm.nih.gov/nuccore/AB238966.1), we can see that while AP011317 and AP011181 are annotated with similar nomenclature, AB238966 differs substantially (e.x. COI vs CO2, Cyt b vs Cb, etc.). For this example, we will use all the arguments of `AnnotationBust` to extract all 38 subsequences for the four accessions (22 tRNAs, 13 CDS, 2 rRNAs, and 1 D-loop). For this we will have to specify duplicates, in this case for tRNA-Leu and tRNA-Ser, which occur twice in vertebrate mitogenomes. We will translate the CDS using `TranslateSeqs` argument with `TranslateCode=2`, the code for vertebrate mitogenomes. Because we have a single accession for each species, we will specify `DuplicateSpecies=FALSE` and have out FASTA files output with the prefix "Demo" by specifying `Prefix="Demo"` and with `TiddyAccessions=TRUE`. This will create 38 FASTA files for all mitochondrial loci in the mitochondrial genome in the working director with the prefix "Demo".

```
#run AnnotationBust function for two duplicate tRNA genes occuring twice and translate CDS
my.seqs<-AnnotationBust(Accessions=my.longest.seqs$Accession, Terms=mtDNAterms,Duplicates=c("tRNA_Leu","tRNA_Ser"), DuplicateInstances=c(2,2), TranslateSeqs=TRUE, TranslateCode=2, DuplicateSpecies=TRUE, Prefix="Demo", TidyAccessions=TRUE)

#We can return the accession table and write it to a CSV file.
my.seqs#retutn the accession table
write.csv(my.seqs, file="AccessionTable.csv")#Write the accession table to a csv file
```

We can also use `AnnotationBustR` to extract introns from sequences. One limitation to this is that the introns must be annotated within the subsequence, which is lacking from some accessions (e.x. not all chloroplasts have introns annotated). As stated above, this requires the use of a fourth column in the search terms, labelled `IntronExonNumber`, which is used to find which number intron is to be extracted. For instance, lets imagine we want to extract the coding sequence matK and exon 2 and intron 1 of trnK from the chloroplast genomes KX687911.1 and KX687910.1 We could set up the search terms as follows using the current `cpDNAterms`:

```
#Subset out matK from cpDNAterms
cds.terms<-subset(cpDNAterms,cpDNAterms$Locus=="matK")
#Create a vecotr of NA so we can merge with the search terms for introns and exons
cds.terms<-cbind(cds.terms,(rep(NA,length(cds.terms$Locus))))
colnames(cds.terms)[4]<-"IntronExonNumber"

#Prepare a search term table for the intron and exons to remove
#We can start with the cpDNAterms for trnK
IntronExon.terms<-subset(cpDNAterms,cpDNAterms$Locus=="trnK")
#As we want to go for two exons, we will want the synonyms repeated as we are doing and intron and an exon
IntronExon.terms<-rbind(IntronExon.terms,IntronExon.terms)#duplicate the terms
IntronExon.terms$Type<-rep(c("Intron","Intron","Exon","Exon"))#rep the sequence type we want to extract
IntronExon.terms$Locus<-rep(c("trnK_Intron","trnK_Exon2"),each=2)
IntronExon.terms<-cbind(IntronExon.terms,rep(c(1,1,2,2)))#Add intron/exon number info
colnames(IntronExon.terms)[4]<-"IntronExonNumber"#change column name for number info for IntronExon name

#We can then merge everything together with MergeSearchTerms terms
IntronExonExampleTerms<-MergeSearchTerms(IntronExon.terms,cds.terms)

#Run AnnotationBust
IntronExon.example<-AnnotationBust(Accessions=c("KX687911.1", "KX687910.1"), Terms=IntronExonExampleTerms, Prefix="DemoIntronExon")
```
## 3.5 Troubleshooting
As `AnnotationBustR` is dependent on access to online databases, it is important that you make sure you have a reliable internet connection while using the package, especially for the `FindLongestSeq` and `AnnotationBust` functions. Additionally, as these functions require access to GenBank and ACNUC, if you have internet access yet are still having issues, check that these sites and there servers are not down or undergoing maintainence, which they do occasionally.

The `AnnotationBust` function may also provide the following warnings and report the following in the accessions table:

"Acc. # Not Found" = The supplied accession number does not seem to exist, check that it is correct.

"Acc. # Not On ACNUC GenBank" = Sometime ACNUC is behind a day or two from NCBI GenBank. To double check the date for the current version of the ACNUC database you can run the following code:

```
ACNUC.GB.Info<-seqinr::choosebank("genbank", infobank=T)
ACNUC.GB.INFO#return info on date
```

"type not fully Ann." = Indicates that the sequence is on GenBank, but is lacking necessary annotation information to fully extract all subsequences. They may be concatenated and not contain position information for each subsequence.

"Warning: In socketConnection(host = host, port = port, server = server, blocking = blocking, :pbil.univ-lyon1.fr:5558 cannot be opened" = There was an issue connecting to ACNUC. This is an error with the seqinr dependency indicating it is having issues connecting to the ACNUC server. This isn't usually common with a solid internet connection, but does occassionally occur when trying to connect to the ANCUC server for the first time during a session.


It is also important to note that refseq numbers are not supported at the moment (i.e. prefixes like XM_ and NC_). This is due to a limitation in our dependency `seqinr`, which only provides access to refseq viruses at present. We have been in contact with the maintainers of `seqinr` and look forward to implementing refseq accessability into AnotationBusR in the future.

## 4: Final Comments
Further information on the functions and their usage can be found in the helpfiles `help(package=AnnotationBustR)`. For any further issues and questions send an email with subject 'AnnotationBustR support' to borstein@umich.edu or post to the issues section on GitHub(https://github.com/sborstein/AnnotationBustR/issues).

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/DataDoc.R
\docType{data}
\name{mtDNAterms}
\alias{mtDNAterms}
\title{Mitochondrial DNA Search Terms for Animals}
\format{
A data frame of of 254 rows and 3 columns
\itemize{
  \item Feature: Feature name, FASTA files will be written with this name.
  \item Type: Type of feature, CDS,tRNA,rRNA,misc_feature, or D-loop.
  \item Name: Name of synonym for a feature to search for.
}
}
\usage{
mtDNAterms
}
\description{
A data frame containing search terms for animal mitochondrial loci. Can be subset for loci of 
 interest. Columns are as follows and users should follow the column format if they wish to
 add search terms using the MergeSearchTerms function:
}
\seealso{
\code{\link{MergeSearchTerms}}
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/FindLongestSeq.R
\name{FindLongestSeq}
\alias{FindLongestSeq}
\title{Find the longest sequence for each species from a list of GenBank accession numbers.}
\usage{
FindLongestSeq(Accessions, BatchSize = 300)
}
\arguments{
\item{Accessions}{A vector of GenBank accession numbers.}

\item{BatchSize}{Numeric. If the number of accessions is over the number provided, requests will be sent in batches of this amount. This is necessary for the NCBI servers. If you receive an HTTP 414 error, try to reduce the size of the batch. Default is 300.}
}
\value{
A list of genbank accessions numbers for the longest sequence for each taxon in a list of accession numbers.
}
\description{
Find the longest sequence for each species from a list of GenBank accession numbers.
}
\details{
For a set of GenBank accession numbers, this will return the longest sequence for in the set for species.
}
\examples{
#a vector of 4 genbank accessions, there are two accessions for each species.
genbank.accessions<-c("KP978059.1","KP978060.1","JX516105.1","JX516111.1")
\dontshow{if (interactive()) withAutoprint(\{ # examplesIf}
#returns the longest sequence respectively for the two species.
long.seq.result <- FindLongestSeq(genbank.accessions)
\dontshow{\}) # examplesIf}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AnnotationBust.R
\name{AnnotationBust}
\alias{AnnotationBust}
\title{Breaks up genbank sequences into their annotated components based on a set of search terms and writes each subsequence of interest to a FASTA for each accession number supplied.}
\usage{
AnnotationBust(
  Accessions,
  Terms,
  Duplicates = NULL,
  DuplicateInstances = NULL,
  TranslateSeqs = "None",
  DuplicateSpecies = FALSE,
  Prefix = NULL,
  TidyAccessions = TRUE,
  Reference = TRUE,
  Verbose = TRUE
)
}
\arguments{
\item{Accessions}{A vector of GenBank accession numbers.}

\item{Terms}{A data frame of search terms. Search terms for animal mitogenomes, nuclear rRNA, chloroplast genomes, and plant mitogenomes are pre-made and can be loaded using the data() function. Additional terms can be added using the MergeSearchTerms function or a user supplied data frame may be provided.}

\item{Duplicates}{A vector of the features  which occur more than once in the sequence and for which the extraction of multiple copies is desired. Default is NULL. In the case more than one copy exists when set to NULL, only the first instance will be extracted.}

\item{DuplicateInstances}{A numeric vector the length of Duplicates of the number of duplicates for each duplicated feature you wish to extract. Only needs to be used if Duplicates are provided.Default is NULL (i.e. no duplicates).}

\item{TranslateSeqs}{Should coding sequences (cds) be translated to the corresponding peptide sequence? Options include, Only, None, or Both. Both returns both the DNA sequence and the corresponding peptide sequence. Default is FALSE.}

\item{DuplicateSpecies}{Logical. As to whether there are duplicate individuals per species. If TRUE, adds the accession number to the fasta header when writing sequences to file.}

\item{Prefix}{Character. If a prefix is specified, all output FASTA files written will begin with the prefix followed by an underscore. Default is NULL (i.e. no prefix).}

\item{TidyAccessions}{Logical. Should the accession table  have a single row per species? If numerous accessions for a species occur, they will be separated by a comma in the accession table. Default=TRUE.}

\item{Reference}{Logical. Should reference information be captured and added as a column to the accession table? Default is TRUE.}

\item{Verbose}{Logical. Should progress be printed to the screen. The current accession and species name will be printed to the screen.}
}
\value{
Writes a fasta file(s) to the current working directory selected for each unique subsequence of interest in Terms containing all the accession numbers the subsequence was found in.

An accesion table of class data.frame.
}
\description{
Breaks up genbank sequences into their annotated components based on a set of search terms and writes each subsequence of interest to a FASTA for each accession number supplied.
}
\details{
The AnnotationBust function takes a vector of accession numbers and a data frame of search terms and extracts subsequences from genomes or concatenated sequences. This function connects directly to the NCBI database and requires a steady internet connection. The function writes files in the FASTA format to the current working directory and returns an accession table. Files append, so use different prefixes between runs, otherwise they will be added to current files in the working directory with the same name. 

AnnotationBustR comes with pre-made search terms for metazoan mitogenomes, plant mitogenomes, chloroplast genomes, and rDNA that can be loaded using data(mtDNAterms), data(mtDNAtermsPlants), data(cpDNAterms), and data(rDNAterms) respectively. Search terms can be completely made by the user if they follow a similar format with three columns. The first, Feature, should contain the name of the features as the user wishes it be displayed in their files as it is used to name the files and create the accession table. We recommend following a similar naming convention to what we currently have in the pre-made data frames to ensure that files are named properly, characters like "-" or ".", and names starting with numbers should be avoided as it can cause errors with R. The second column, Type, contains the type of subsequence it is (eg. CDS, exon, intron, rRNA, tRNA, misc_RNA, misc_feature, D_Loop). The last column, Name, consists of a possible synonym for the feature of interest as it might appear in an annotation. For numerous synonyms for the same locus, one should have each synonym as its own row. An additional fourth column is needed for extracting introns/exons. This column, called IntronExonNumber should contain the number of the desired intron or exon to extract. If extracting both introns/exons and non-intron/exon sequences the fourth column should be NA for non-intron/exon sequence types. See the examples below and the vignette for detailed examples on extracting intron and exons. 

In the event that an accession is not found on NCBI, the message “Accession # not found on NBI”.

For a more detailed walk-through on using AnnotationBust you can access the vignette with vignette("AnnotationBustR).
}
\examples{
\dontshow{if (interactive()) withAutoprint(\{ # examplesIf}
\donttest{
ncbi.accessions <- c("FJ706295","FJ706343","FJ706292")
data(rDNAterms)#load rDNA search terms from AnnotationBustR
my.sequences <- AnnotationBust(Accessions = ncbi.accessions, rDNAterms, DuplicateSpecies=TRUE, 
Prefix="Example1", Reference = TRUE)
my.sequences

###Example With matK CDS and addint introns/exons for trnK###
#Subset out matK from cpDNAterms
cds.terms <- subset(cpDNAterms,cpDNAterms$Feature=="matK")
#Create a vecotr of NA so we can merge with the search terms for introns and exons
cds.terms <- cbind(cds.terms,(rep(NA,length(cds.terms$Feature))))
colnames(cds.terms)[4] <- "IntronExonNumber"

#Prepare a search term table for the intron and exons to remove
#We can start with the cpDNAterms for trnK
IntronExon.terms<-subset(cpDNAterms,cpDNAterms$Feature=="trnK")

#As we want to go for two exons, we will want the synonyms repeated as we are doing and intron
#and an exon
IntronExon.terms<-rbind(IntronExon.terms,IntronExon.terms)#duplicate the terms

#rep the sequence type we want to extract
IntronExon.terms$Type <- rep(c("intron","intron","exon","exon"))
IntronExon.terms$Feature <- rep(c("trnK_Intron","trnK_Exon2"),each=2)
IntronExon.terms <- cbind(IntronExon.terms,rep(c(1,1,2,2)))#Add intron/exon number info

#change column name for number info for IntronExon name
colnames(IntronExon.terms)[4] <- "IntronExonNumber"

#We can then merge everything together with MergeSearchTerms terms
IntronExonExampleTerms <- MergeSearchTerms(IntronExon.terms,cds.terms)

#Run AnnotationBust
IntronExon.example <- AnnotationBust(Accessions=c("KX687911.1", "KX687910.1"),
Terms=IntronExonExampleTerms, Prefix="DemoIntronExon")
}
\dontshow{\}) # examplesIf}
}
\references{
Borstein SR, and O’Meara BC. 2018. AnnotationBustR: an R package to extract subsequences from GenBank annotations. PeerJ 6:e5179. 10.7717/peerj.5179.
}
\author{
Samuel R. Borstein, Brian C. O'Meara
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/MergeSearchTerms.R
\name{MergeSearchTerms}
\alias{MergeSearchTerms}
\title{Merging of two tables containing search terms to expand search term database for the AnnotationBust function.}
\usage{
MergeSearchTerms(..., SortGenes = FALSE)
}
\arguments{
\item{...}{the data frames of search terms you want to combine into a single data frame The Data frame(s) should have stringsAsFactors=FALSE listed if you want to sort them.}

\item{SortGenes}{Should the final data frame be sorted by gene name? Default is FALSE.}
}
\value{
A new merged data frame with all the search terms combined from the lists supplied. If sort.gene=TRUE, genes will be sorted by name.
}
\description{
This function merges two data frames with search terms. This allows users to easily add search terms to data frames (either their
own or ones included in this package using data() as GenBank annotations for the same genes may vary in gene name.
}
\examples{
#load the list of search terms for mitochondrial genes
data(mtDNAterms) 

#Make a data.frame of new terms to add.
#This is a dummy example for a non-real annotation of COI, but lets pretend it is real.
add.name <- data.frame("COI","CDS", "CX1")

# make the column names the same for combination.
colnames(add.name) <- colnames(mtDNAterms)

#Run the merge search term function without sorting based on gene name.
new.terms <- MergeSearchTerms(add.name, mtDNAterms, SortGenes=FALSE)

#Run the merge search term function with sorting based on gene name.
new.terms <- MergeSearchTerms(add.name, mtDNAterms, SortGenes=TRUE)

#Merge search terms and create an additional column for introns and/or exons to extract
#In this example, add the trnK intron to the terms

###Example With matK CDS and addint introns/exons for trnK###
#Subset out matK from cpDNAterms
cds.terms <- subset(cpDNAterms,cpDNAterms$Feature=="matK")
#Create a vecotr of NA so we can merge with the search terms for introns and exons
cds.terms <- cbind(cds.terms,(rep(NA,length(cds.terms$Feature))))
colnames(cds.terms)[4] <- "IntronExonNumber"

#Prepare a search term table for the intron and exons to remove
#We can start with the cpDNAterms for trnK
IntronExon.terms<-subset(cpDNAterms,cpDNAterms$Feature=="trnK")

#As we want to go for two exons, we will want the synonyms repeated as we are doing and intron
#and an exon
IntronExon.terms<-rbind(IntronExon.terms,IntronExon.terms)#duplicate the terms

#rep the sequence type we want to extract
IntronExon.terms$Type <- rep(c("intron","intron","exon","exon"))
IntronExon.terms$Feature <- rep(c("trnK_Intron","trnK_Exon2"),each=2)
IntronExon.terms <- cbind(IntronExon.terms,rep(c(1,1,2,2)))#Add intron/exon number info

#change column name for number info for IntronExon name
colnames(IntronExon.terms)[4] <- "IntronExonNumber"

#We can then merge everything together with MergeSearchTerms terms
IntronExonExampleTerms <- MergeSearchTerms(IntronExon.terms,cds.terms)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pkgname.R
\name{AnnotationBustR}
\alias{AnnotationBustR}
\title{An R package to extract sub-sequences from GenBank annotations under different synonyms}
\description{
An R package to extract sub-sequences from GenBank annotations under different synonyms.
}
\details{
Package: AnnotationBustR

Type: Package

Title: An R package to extract sub-sequences from GenBank annotations under different synonyms

Version: 2.0

Date: 2026-6-16

License: GPL (>= 2)

This package allows users to quickly extract sub-sequences from GenBank accession numbers that may be annotated
under different synonyms. It writes these sub-sequences to FASTA files and creates a corresponding accession
table. The package comes with pre-made search terms with synonyms. A vignette going over the basic functions and
how to use them can be accessed with vignette("AnnotationBustR-vignette").
}
\seealso{
\code{\link{AnnotationBust}},\code{\link{cpDNAterms}},\code{\link{FindLongestSeq}},\code{\link{MergeSearchTerms}},\code{\link{mtDNAterms}},\code{\link{rDNAterms}}
}
\author{
Samuel Borstein, Brian O'Meara.
Maintainer: Samuel Borstein <sam@borstein.com>
}
